#ifndef VDM_header_knaps
#define VDM_header_knaps


/* ------- PHASE1 ------------------ */
/*
module generated from VDM Class Library
$Revision: 1.101 $
$Date: 1996/09/19 09:25:46 $
*/

#if defined(sun) && ! defined(sparc)
#define __BSD42__
#endif

#ifdef M_XENIX
#define __XENIX__
#define __SYSV__
#endif

#ifdef __TURBOC__
#define __DOS__
#endif

#if defined(__TURBOC__) || defined(__ANSIC__) || defined(__STDC__)
typedef void * VOIDptr;
#else
typedef char * VOIDptr;
#endif

#if defined(__linux__) || defined(_AIX) || defined(MIPSEL) || (defined(sun) && defined(sparc))
#ifndef __POSIX
#define __POSIX
#endif
#endif

#ifdef __cplusplus
#include <stdlib.h>
#else
#if defined(__STDC__) || defined(__POSIX)
#ifndef apollo
#include <stdlib.h>
#endif
#endif
#endif

#ifdef __cplusplus
#include <stdio.h>
#endif

#ifdef __cplusplus
#include <iostream.h>
#else
#include <stdio.h>
#endif

#include <stdio.h>

#include <float.h>

#ifdef __BSD42__
#include <strings.h>
#else
#include <string.h>
#endif

/* some systems define TRUE and FALSE in system header files */
#ifndef FALSE
#ifndef TRUE

/* Bool as enum requires conversion between enum and int */
#ifdef BoolAsEnum
enum {FALSE,TRUE};
#else
#define FALSE ((unsigned char)0)
#define TRUE ((unsigned char)1)
#endif

#ifdef __cplusplus
#define false BOOL(FALSE)
#define true BOOL(TRUE)
#endif

#endif
#endif

typedef unsigned char Bool;

typedef double Real;

#define lb_nat1 1

#define ub_nat1 2147483647

typedef unsigned long Nat1;

#define lb_nat0 0

#define ub_nat0 2147483647

typedef unsigned long Nat0;

#define lb_intg -2147483647

#define ub_intg 2147483647

typedef long int Intg;

typedef char Char;
#define lb_char 0

#define ub_char 255

typedef struct Struct_rep_str * Rep_str;
typedef struct Handle_str * Str;
typedef struct Struct_cvtext_vdmlib * Cvtext_vdmlib;
typedef struct Struct_rep_chromosome * Rep_chromosome;
typedef struct Struct_rep_confill * Rep_confill;
typedef struct Handle_chromosome * Chromosome;
typedef struct Handle_container * Container;
typedef struct Handle_block * Block;
typedef struct Handle_confill * ConFill;
typedef struct Struct_rep_blocks * Rep_blocks;
typedef struct Handle_individual * Individual;
typedef struct Handle_blocks * Blocks;
typedef struct Struct_rep_individuals * Rep_individuals;
typedef struct Handle_individuals * Individuals;
typedef struct Handle_population * Population;
typedef struct Handle_ga * Ga;

/* ------- PHASE2 ------------------ */
#define VDM_ERR_EMPTYSET 1
#define VDM_ERR_EMPTYMAP 2
#define VDM_ERR_EMPTYHD 3
#define VDM_ERR_ERRMAXLEN 4
#define VDM_ERR_NILPTR 5
#define VDM_ERR_NILOPT 6
#define VDM_ERR_ILLPTR 7
#define VDM_ERR_SELECT 8
#define VDM_ERR_SELMAP 9
#define VDM_ERR_UNIO 10
#define VDM_ERR_EMPTYTL 11
#define VDM_ERR_UNION 12
#define VDM_ERR_NOTIMPL 13
#define VDM_ERR_HEAPOFL 15
#define VDM_ERR_CVLINES 16
#define VDM_ERR_NV_HDL 17
#define VDM_ERR_EMPTYIT 18
#define VDM_ERR_DIV0 19

extern Bool supress_cvlines_vdmlib;
extern Nat0 curr_linelen_vdmlib;
extern char *start_structure_vdmlib;
extern char *end_structure_vdmlib;

extern void adj_linelen_vdmlib ( Nat0 x1 ) ;
extern Str ident_prefix_vdmlib ( Str x1, Nat0 x2 ) ;
extern Cvtext_vdmlib ident_lines_vdmlib ( Cvtext_vdmlib x1, Str x2 ) ;
extern Cvtext_vdmlib close_struct_vdmlib ( Cvtext_vdmlib x1,Str x2, Nat0 x3 ) ;
extern Cvtext_vdmlib append_lastline_vdmlib ( Cvtext_vdmlib x1,Cvtext_vdmlib x2 ) ;
extern Cvtext_vdmlib cvlines2_cvtext_vdmlib ( Cvtext_vdmlib x1,Cvtext_vdmlib x2 ) ;
#ifdef __cplusplus
extern void fprint_lines_vdmlib ( ostream & x1,Cvtext_vdmlib x2 ) ;
#else
extern void fprint_lines_vdmlib ( FILE *x1,Cvtext_vdmlib x2 ) ;
#endif

#ifdef __cplusplus
inline VOIDptr ALLOCMEM_vdmlib(unsigned long int x1)
{ return (VOIDptr)(new char[x1]); }
inline void FREEMEM_vdmlib(VOIDptr x1,unsigned long int)
{ delete (char *)(x1); }
#else
#if ! defined(__STDC__) && ! defined(_AIX) && ! defined(__NOMALLOC__)
extern VOIDptr malloc ( unsigned long x1 ) ;
extern void free ( VOIDptr x1 ) ;
#endif
#define ALLOCMEM_vdmlib(x1) malloc(x1)
#define FREEMEM_vdmlib(x1,x2) free(x1)
#endif

#define Gen Nat1

struct Struct_rep_str {
Nat0 f_max;
Nat0 f_len;
};

struct Handle_str {
Rep_str f_rep;
Nat0 f_rc;
};

#define AUTOMEM_str

void cond_clone_str ( Str * ) ;

#define check_handle_str(h) if ((h) == 0) err_nv_hdl_vdmlib("Str");

struct Struct_cvtext_vdmlib {
Nat0 f_max;
Nat0 f_len;
};
struct Struct_rep_chromosome {
Nat0 f_max;
Nat0 f_len;
};
#define cvlines2_rep_chromosome(x1,x2) cvlines2_vdmlib(x1,x2)

struct Struct_rep_container {

Nat0 f_rep_cwidth_container_rep_container;

Nat0 f_rep_cheight_container_rep_container;

};

typedef struct Struct_rep_container Rep_container;

#define cvlines2_rep_container(x1,x2) cvlines2_vdmlib(x1,x2)
struct Struct_rep_block {

Nat0 f_rep_bwidth_block_rep_block;

Nat0 f_rep_bheight_block_rep_block;

Nat0 f_rep_x_block_rep_block;

Nat0 f_rep_y_block_rep_block;

};

typedef struct Struct_rep_block Rep_block;

#define cvlines2_rep_block(x1,x2) cvlines2_vdmlib(x1,x2)
struct Struct_rep_confill {
Nat0 f_max;
Nat0 f_len;
};
#define cvlines2_rep_confill(x1,x2) cvlines2_vdmlib(x1,x2)

struct Handle_chromosome {
Rep_chromosome f_rep;
Nat0 f_rc;
};

#define AUTOMEM_chromosome

void cond_clone_chromosome ( Chromosome * ) ;

#define check_handle_chromosome(h) if ((h) == 0) err_nv_hdl_vdmlib("Chromosome");

struct Handle_container {
Rep_container f_rep;
Nat0 f_rc;
};

#define AUTOMEM_container

void cond_clone_container ( Container * ) ;

#define check_handle_container(h) if ((h) == 0) err_nv_hdl_vdmlib("Container");

struct Handle_block {
Rep_block f_rep;
Nat0 f_rc;
};

#define AUTOMEM_block

void cond_clone_block ( Block * ) ;

#define check_handle_block(h) if ((h) == 0) err_nv_hdl_vdmlib("Block");

struct Handle_confill {
Rep_confill f_rep;
Nat0 f_rc;
};

#define AUTOMEM_confill

void cond_clone_confill ( ConFill * ) ;

#define check_handle_confill(h) if ((h) == 0) err_nv_hdl_vdmlib("ConFill");
struct Struct_iter_rep_chromosome {
Rep_chromosome f_array;
unsigned f_curser;
};

typedef struct Struct_iter_rep_chromosome Iter_rep_chromosome;
struct Struct_iter_rep_confill {
Rep_confill f_array;
unsigned f_curser;
};

typedef struct Struct_iter_rep_confill Iter_rep_confill;

struct Struct_iter_chromosome {
Iter_rep_chromosome f_ir;
Chromosome f_vl;
};

typedef struct Struct_iter_chromosome Iter_chromosome;
struct Struct_iter_confill {
Iter_rep_confill f_ir;
ConFill f_vl;
};

typedef struct Struct_iter_confill Iter_confill;
struct Struct_rep_individual {

Chromosome f_rep_chrom_individual_rep_individual;

Real f_rep_fitness_individual_rep_individual;

};

typedef struct Struct_rep_individual Rep_individual;

#define cvlines2_rep_individual(x1,x2) cvlines2_vdmlib(x1,x2)
struct Struct_rep_blocks {
Nat0 f_max;
Nat0 f_len;
};
#define cvlines2_rep_blocks(x1,x2) cvlines2_vdmlib(x1,x2)

struct Handle_individual {
Rep_individual f_rep;
Nat0 f_rc;
};

#define AUTOMEM_individual

void cond_clone_individual ( Individual * ) ;

#define check_handle_individual(h) if ((h) == 0) err_nv_hdl_vdmlib("Individual");

struct Handle_blocks {
Rep_blocks f_rep;
Nat0 f_rc;
};

#define AUTOMEM_blocks

void cond_clone_blocks ( Blocks * ) ;

#define check_handle_blocks(h) if ((h) == 0) err_nv_hdl_vdmlib("Blocks");
struct Struct_iter_rep_blocks {
Rep_blocks f_array;
unsigned f_curser;
};

typedef struct Struct_iter_rep_blocks Iter_rep_blocks;

struct Struct_iter_blocks {
Iter_rep_blocks f_ir;
Blocks f_vl;
};

typedef struct Struct_iter_blocks Iter_blocks;
struct Struct_rep_individuals {
Nat0 f_max;
Nat0 f_len;
};
#define cvlines2_rep_individuals(x1,x2) cvlines2_vdmlib(x1,x2)

struct Handle_individuals {
Rep_individuals f_rep;
Nat0 f_rc;
};

#define AUTOMEM_individuals

void cond_clone_individuals ( Individuals * ) ;

#define check_handle_individuals(h) if ((h) == 0) err_nv_hdl_vdmlib("Individuals");
struct Struct_iter_rep_individuals {
Rep_individuals f_array;
unsigned f_curser;
};

typedef struct Struct_iter_rep_individuals Iter_rep_individuals;
struct Struct_iter_individuals {
Iter_rep_individuals f_ir;
Individuals f_vl;
};

typedef struct Struct_iter_individuals Iter_individuals;
struct Struct_rep_population {

Individuals f_rep_ind_population_rep_population;

Nat1 f_rep_popsize_population_rep_population;

Nat1 f_rep_stringlen_population_rep_population;

Nat1 f_rep_step_population_rep_population;

Nat1 f_rep_best_population_rep_population;

Nat1 f_rep_worst_population_rep_population;

Real f_rep_bestf_population_rep_population;

Real f_rep_worstf_population_rep_population;

Real f_rep_sumfitness_population_rep_population;

};

typedef struct Struct_rep_population Rep_population;

#define cvlines2_rep_population(x1,x2) cvlines2_vdmlib(x1,x2)

struct Handle_population {
Rep_population f_rep;
Nat0 f_rc;
};

#define AUTOMEM_population

void cond_clone_population ( Population * ) ;

#define check_handle_population(h) if ((h) == 0) err_nv_hdl_vdmlib("Population");
struct Struct_rep_ga {

Nat1 f_rep_popsize_ga_rep_ga;

Nat1 f_rep_stringlen_ga_rep_ga;

Population f_rep_oldpop_ga_rep_ga;

Population f_rep_newpop_ga_rep_ga;

Real f_rep_pcross_ga_rep_ga;

Real f_rep_pmutation_ga_rep_ga;

Real f_rep_maxchange_ga_rep_ga;

Nat0 f_rep_generation_ga_rep_ga;

Container f_rep_con_ga_rep_ga;

Blocks f_rep_bl_ga_rep_ga;

Nat0 f_rep_containers_ga_rep_ga;

};

typedef struct Struct_rep_ga Rep_ga;

#define cvlines2_rep_ga(x1,x2) cvlines2_vdmlib(x1,x2)

struct Handle_ga {
Rep_ga f_rep;
Nat0 f_rc;
};

#define AUTOMEM_ga

void cond_clone_ga ( Ga * ) ;

#define check_handle_ga(h) if ((h) == 0) err_nv_hdl_vdmlib("Ga");

/* ------- PHASE3 ------------------ */
extern Str alloc_str ( void );
extern void free_str ( Str x1 );

#define ref_str(x1) (x1)

extern void profile_str ( void );

extern void err_empty_iterator_vdmlib ( char *x1 );
extern void abort_vdmlib ( Nat0 x1 );
extern void heap_oflw_vdmlib ( char *x1 );
extern void err_nv_hdl_vdmlib ( char *x1 );
extern void err_sel_vdmlib ( Nat1 x1 , Nat0 x2 , char *x3 );
extern void err_tl_vdmlib ( char *x1 );
extern Bool not_bool ( Bool x1 );
extern Bool is_gr_bool ( Bool x1 , Bool x2 );
extern Bool xor_bool ( Bool x1 , Bool x2 );
extern Bool and_bool ( Bool x1 , Bool x2 );
extern Bool is_eq_bool ( Bool x1 , Bool x2 );
extern Bool is_ge_bool ( Bool x1 , Bool x2 );
extern Bool or_bool ( Bool x1 , Bool x2 );
extern Chromosome alloc_chromosome ( void );
extern void free_chromosome ( Chromosome x1 );

#define ref_chromosome(x1) (x1)

extern void profile_chromosome ( void );

extern Individuals alloc_individuals ( void );
extern void free_individuals ( Individuals x1 );

#define ref_individuals(x1) (x1)

extern void profile_individuals ( void );

extern Blocks alloc_blocks ( void );
extern void free_blocks ( Blocks x1 );

#define ref_blocks(x1) (x1)

extern void profile_blocks ( void );

extern ConFill alloc_confill ( void );
extern void free_confill ( ConFill x1 );

#define ref_confill(x1) (x1)

extern void profile_confill ( void );

extern Real copy_real ( Real x1 );
extern char * printformat_real;

extern void set_print_format_real ( char * x1 );
extern Real minus_real ( Real x1 , Real x2 );
extern Real div_real ( Real x1 , Real x2 );
extern Bool is_gr_real ( Real x1 , Real x2 );
extern Bool is_le_real ( Real x1 , Real x2 );
extern Real succ_real ( Real x1 );
extern Cvtext_vdmlib cvlines_real ( Real x1 );
/* global variable 'curr_linelen_vdmlib' determines line length */
#ifdef __cplusplus
extern void fpr_real ( ostream & x1 , Real x2 );
#else
extern void fpr_real ( FILE *x1 , Real x2 );
#endif
extern Real plus_real ( Real x1 , Real x2 );
extern Real times_real ( Real x1 , Real x2 );
extern Bool is_ge_real ( Real x1 , Real x2 );
extern Bool is_lt_real ( Real x1 , Real x2 );
extern Bool is_eq_real ( Real x1 , Real x2 );
extern Real pred_real ( Real x1 );
extern void del_real ( Real x1 );
extern char * printformat_nat1;

extern void set_print_format_nat1 ( char * x1 );
extern Nat1 pred_nat1 ( Nat1 x1 );
extern Bool is_eq_nat1 ( Nat1 x1 , Nat1 x2 );
extern Bool is_lt_nat1 ( Nat1 x1 , Nat1 x2 );
extern Bool is_ge_nat1 ( Nat1 x1 , Nat1 x2 );
extern Nat1 times_nat1 ( Nat1 x1 , Nat1 x2 );
extern Nat1 plus_nat1 ( Nat1 x1 , Nat1 x2 );
extern void del_nat1 ( Nat1 x1 );
extern Nat1 copy_nat1 ( Nat1 x1 );
extern Nat1 succ_nat1 ( Nat1 x1 );

extern Nat1 mod_nat1 ( Nat1 x1 , Nat1 x2 );

extern Bool is_le_nat1 ( Nat1 x1 , Nat1 x2 );
extern Bool is_gr_nat1 ( Nat1 x1 , Nat1 x2 );
extern Nat1 div_nat1 ( Nat1 x1 , Nat1 x2 );
extern Nat1 minus_nat1 ( Nat1 x1 , Nat1 x2 );
extern Cvtext_vdmlib cvlines_nat1 ( Nat1 x1 );
/* global variable 'curr_linelen_vdmlib' determines line length */
extern char * printformat_nat0;

extern void set_print_format_nat0 ( char * x1 );
extern Nat0 pred_nat0 ( Nat0 x1 );
extern Bool is_eq_nat0 ( Nat0 x1 , Nat0 x2 );
extern Bool is_lt_nat0 ( Nat0 x1 , Nat0 x2 );
extern Bool is_ge_nat0 ( Nat0 x1 , Nat0 x2 );
extern Nat0 times_nat0 ( Nat0 x1 , Nat0 x2 );
extern Nat0 plus_nat0 ( Nat0 x1 , Nat0 x2 );
extern void del_nat0 ( Nat0 x1 );
extern Nat0 copy_nat0 ( Nat0 x1 );
extern Nat0 succ_nat0 ( Nat0 x1 );

extern Nat0 mod_nat0 ( Nat0 x1 , Nat0 x2 );

extern Bool is_le_nat0 ( Nat0 x1 , Nat0 x2 );
extern Bool is_gr_nat0 ( Nat0 x1 , Nat0 x2 );
extern Nat0 div_nat0 ( Nat0 x1 , Nat0 x2 );
extern Nat0 minus_nat0 ( Nat0 x1 , Nat0 x2 );
extern Cvtext_vdmlib cvlines_nat0 ( Nat0 x1 );
/* global variable 'curr_linelen_vdmlib' determines line length */
extern Intg pred_intg ( Intg x1 );
extern Bool is_eq_intg ( Intg x1 , Intg x2 );
extern Bool is_lt_intg ( Intg x1 , Intg x2 );
extern Bool is_ge_intg ( Intg x1 , Intg x2 );
extern Intg times_intg ( Intg x1 , Intg x2 );
extern Intg plus_intg ( Intg x1 , Intg x2 );
extern Intg succ_intg ( Intg x1 );

extern Intg mod_intg ( Intg x1 , Intg x2 );

extern Bool is_le_intg ( Intg x1 , Intg x2 );
extern Bool is_gr_intg ( Intg x1 , Intg x2 );
extern Intg div_intg ( Intg x1 , Intg x2 );
extern Intg minus_intg ( Intg x1 , Intg x2 );
extern Char copy_char ( Char x1 );
extern Char pred_char ( Char x1 );
extern Bool is_eq_char ( Char x1 , Char x2 );
extern Bool is_lt_char ( Char x1 , Char x2 );
extern Bool is_ge_char ( Char x1 , Char x2 );
extern Char times_char ( Char x1 , Char x2 );
extern Char plus_char ( Char x1 , Char x2 );
extern Char succ_char ( Char x1 );

extern Char mod_char ( Char x1 , Char x2 );

extern Bool is_le_char ( Char x1 , Char x2 );
extern Bool is_gr_char ( Char x1 , Char x2 );
extern Char div_char ( Char x1 , Char x2 );
extern Char minus_char ( Char x1 , Char x2 );
extern void del_char ( Char x1 );
#define cvlines_gen cvlines_nat1
#define copy_gen copy_nat1
#define default_gen default_nat1
#define del_gen del_nat1
extern Rep_str alloc_rep_str ( Nat0 x1 );
extern void free_rep_str ( Rep_str x1 );

#define ref_rep_str(x1) (x1)

#define profile_rep_str()

typedef void (* T2_forall_rep_str) ( Char y1 ) ;
extern void forall_rep_str ( Rep_str x1, T2_forall_rep_str x2 ) ;
extern void del1_rep_str ( Rep_str x1 );
extern Rep_str mknc_rep_str ( Char x1 , Nat0 x2 );
extern Rep_str ovwrt1d_rep_str ( Rep_str x1 , Nat1 x2 , Char x3 );
extern Rep_str conc_rep_str ( Rep_str x1 , Rep_str x2 );
extern void cpc_rep_str ( Rep_str x1 , Char *x2 );
extern Char sel_rep_str ( Rep_str x1 , Nat1 x2 );
extern Rep_str copy_rep_str ( Rep_str x1 );
extern Rep_str mkc_rep_str ( Char *x1 );
extern void del_rep_str ( Rep_str x1 );
extern Char hd_rep_str ( Rep_str x1 );
extern Nat0 index_rep_str ( Rep_str x1 , Char x2 );
extern Nat0 len_rep_str ( Rep_str x1 );
typedef void (* T2_forindex_rep_str) ( Char y1, Nat1 y2 ) ;
extern void forindex_rep_str ( Rep_str x1, T2_forindex_rep_str x2 ) ;
extern Rep_chromosome alloc_rep_chromosome ( Nat0 x1 );
extern void free_rep_chromosome ( Rep_chromosome x1 );

#define ref_rep_chromosome(x1) (x1)

#define profile_rep_chromosome()

extern Rep_confill alloc_rep_confill ( Nat0 x1 );
extern void free_rep_confill ( Rep_confill x1 );

#define ref_rep_confill(x1) (x1)

#define profile_rep_confill()

extern Nat0 len_str ( Str x1 );
extern Nat0 index_str ( Str x1 , Char x2 );
extern Char hd_str ( Str x1 );
extern Str conc_str ( Str x1 , Str x2 );
extern Str conc_auto_str ( Str x1 , Str x2 );
extern Char sel_str ( Str x1 , Nat1 x2 );
extern void cpc_str ( Str x1 , Char *x2 );
extern Str mkc_str ( Char *x1 );
extern void del_str ( Str x1 );
extern Str copy_str ( Str x1 );
extern Str ovwrt1_str ( Str x1 , Nat1 x2 , Char x3 );
extern Str mkn_str ( Char x1 , Nat0 x2 );
extern Cvtext_vdmlib alloc_cvtext_vdmlib ( Nat0 x1 );
extern void free_cvtext_vdmlib ( Cvtext_vdmlib x1 );

#define ref_cvtext_vdmlib(x1) (x1)

#define profile_cvtext_vdmlib()

typedef void (* T2_forall_cvtext_vdmlib) ( Str y1 ) ;
extern void forall_cvtext_vdmlib ( Cvtext_vdmlib x1, T2_forall_cvtext_vdmlib x2 ) ;
extern Nat0 len_cvtext_vdmlib ( Cvtext_vdmlib x1 );
extern Bool is_empty_cvtext_vdmlib ( Cvtext_vdmlib x1 );
extern void del_cvtext_vdmlib ( Cvtext_vdmlib x1 );
extern Str hd_cvtext_vdmlib ( Cvtext_vdmlib x1 );
extern Cvtext_vdmlib ovwrt1_cvtext_vdmlib ( Cvtext_vdmlib x1 , Nat1 x2 , Str x3 );
extern Cvtext_vdmlib mk1_cvtext_vdmlib ( Str x1 );
extern Cvtext_vdmlib appr_cvtext_vdmlib ( Cvtext_vdmlib x1 , Str x2 );
extern Cvtext_vdmlib conc_cvtext_vdmlib ( Cvtext_vdmlib x1 , Cvtext_vdmlib x2 );
extern Cvtext_vdmlib mk_empty_cvtext_vdmlib ( void );
extern Str last_cvtext_vdmlib ( Cvtext_vdmlib x1 );
extern Str sel_cvtext_vdmlib ( Cvtext_vdmlib x1 , Nat1 x2 );
extern void del1_cvtext_vdmlib ( Cvtext_vdmlib x1 );
extern Rep_chromosome sub_tupd_rep_chromosome ( Rep_chromosome x1 , Nat1 x2 , Nat0 x3 );
typedef void (* T2_forindex_rep_chromosome) ( Gen y1, Nat1 y2 ) ;
extern void forindex_rep_chromosome ( Rep_chromosome x1, T2_forindex_rep_chromosome x2 ) ;
extern Rep_chromosome mk1_rep_chromosome ( Gen x1 );
extern Rep_chromosome mknc_rep_chromosome ( Gen x1 , Nat0 x2 );
extern Rep_chromosome ovwrt1d_rep_chromosome ( Rep_chromosome x1 , Nat1 x2 , Gen x3 );
extern Rep_chromosome copy_rep_chromosome ( Rep_chromosome x1 );
extern Rep_chromosome rmv1d_rep_chromosome ( Rep_chromosome x1 , Nat1 x2 );
extern Cvtext_vdmlib cvlines_rep_chromosome ( Rep_chromosome x1 );
/* global variable 'curr_linelen_vdmlib' determines line length */
extern Rep_chromosome conc_rep_chromosome ( Rep_chromosome x1 , Rep_chromosome x2 );
extern Rep_chromosome tld_rep_chromosome ( Rep_chromosome x1 );
extern void del_rep_chromosome ( Rep_chromosome x1 );
extern void del1_rep_chromosome ( Rep_chromosome x1 );
extern Rep_chromosome appr_rep_chromosome ( Rep_chromosome x1 , Gen x2 );

extern Cvtext_vdmlib cvlines1_rep_chromosome ( Rep_chromosome x1 );

typedef void (* T2_forall_rep_chromosome) ( Gen y1 ) ;
extern void forall_rep_chromosome ( Rep_chromosome x1, T2_forall_rep_chromosome x2 ) ;

extern Cvtext_vdmlib cvlines1_rep_container ( Rep_container x1 );

extern void del_rep_container ( Rep_container x1 );

extern Rep_container chg_rep_cwidth_container_rep_container ( Rep_container x1 , Nat0 x2 );

extern Rep_container chg_rep_cheight_container_rep_container ( Rep_container x1 , Nat0 x2 );

extern Cvtext_vdmlib cvlines_rep_container ( Rep_container x1 );
/* global variable 'curr_linelen_vdmlib' determines line length */
extern Rep_container copy_rep_container ( Rep_container x1 );
extern Rep_container mk_rep_container

(

Nat0 x1_rep_cwidth_container_rep_container
,
Nat0 x1_rep_cheight_container_rep_container

)

;

extern Cvtext_vdmlib cvlines1_rep_block ( Rep_block x1 );

extern void del_rep_block ( Rep_block x1 );

extern Rep_block chg_rep_bwidth_block_rep_block ( Rep_block x1 , Nat0 x2 );

extern Rep_block chg_rep_bheight_block_rep_block ( Rep_block x1 , Nat0 x2 );

extern Rep_block chg_rep_x_block_rep_block ( Rep_block x1 , Nat0 x2 );

extern Rep_block chg_rep_y_block_rep_block ( Rep_block x1 , Nat0 x2 );

extern Cvtext_vdmlib cvlines_rep_block ( Rep_block x1 );
/* global variable 'curr_linelen_vdmlib' determines line length */
extern Rep_block copy_rep_block ( Rep_block x1 );
extern Rep_block mk_rep_block

(

Nat0 x1_rep_bwidth_block_rep_block
,
Nat0 x1_rep_bheight_block_rep_block
,
Nat0 x1_rep_x_block_rep_block
,
Nat0 x1_rep_y_block_rep_block

)

;
typedef void (* T2_forall_rep_confill) ( Nat0 y1 ) ;
extern void forall_rep_confill ( Rep_confill x1, T2_forall_rep_confill x2 ) ;
extern Rep_confill sub_tupd_rep_confill ( Rep_confill x1 , Nat1 x2 , Nat0 x3 );

extern Cvtext_vdmlib cvlines1_rep_confill ( Rep_confill x1 );

extern void del_rep_confill ( Rep_confill x1 );
extern Rep_confill appr_rep_confill ( Rep_confill x1 , Nat0 x2 );
extern Cvtext_vdmlib cvlines_rep_confill ( Rep_confill x1 );
/* global variable 'curr_linelen_vdmlib' determines line length */
extern Rep_confill ovwrt1d_rep_confill ( Rep_confill x1 , Nat1 x2 , Nat0 x3 );
extern Rep_confill copy_rep_confill ( Rep_confill x1 );
extern Rep_confill mknc_rep_confill ( Nat0 x1 , Nat0 x2 );
extern Rep_confill conc_rep_confill ( Rep_confill x1 , Rep_confill x2 );
extern Rep_confill tld_rep_confill ( Rep_confill x1 );
extern Rep_confill mk1_rep_confill ( Nat0 x1 );
extern void del1_rep_confill ( Rep_confill x1 );
extern Chromosome copy_chromosome ( Chromosome x1 );
extern Nat0 len_chromosome ( Chromosome x1 );
extern Chromosome appr_chromosome ( Chromosome x1 , Gen x2 );
extern Chromosome copy1_chromosome ( Chromosome x1 );
extern Chromosome appl_chromosome ( Gen x1 , Chromosome x2 );
extern Bool is_empty_chromosome ( Chromosome x1 );
extern Cvtext_vdmlib cvlines_chromosome ( Chromosome x1 );
/* global variable 'curr_linelen_vdmlib' determines line length */

extern Nat0 Position_chromosome ( Chromosome x1, Nat1 x2 );

extern Chromosome ovwrt1_chromosome ( Chromosome x1 , Nat1 x2 , Gen x3 );
extern Chromosome rmv1_chromosome ( Chromosome x1 , Nat1 x2 );
extern Chromosome mkn_chromosome ( Gen x1 , Nat0 x2 );
#ifdef __cplusplus
extern void fpr_chromosome ( ostream & x1 , Chromosome x2 );
#else
extern void fpr_chromosome ( FILE *x1 , Chromosome x2 );
#endif

extern Chromosome Exchange_chromosome ( Chromosome x1, Nat1 x2, Nat1 x3 );

extern Chromosome mk_empty_chromosome ( void );
extern Gen hd_chromosome ( Chromosome x1 );
extern Chromosome conc_chromosome ( Chromosome x1 , Chromosome x2 );
extern void del1_chromosome ( Chromosome x1 );
extern Chromosome tl_chromosome ( Chromosome x1 );
extern Gen sel_chromosome ( Chromosome x1 , Nat1 x2 );
extern Chromosome mk1_chromosome ( Gen x1 );
extern void del_chromosome ( Chromosome x1 );
extern Container copy_container ( Container x1 );
extern void del_container ( Container x1 );

extern Nat0 s_cwidth_container ( Container x1 );

extern Nat0 s_cheight_container ( Container x1 );

extern void del1_container ( Container x1 );
extern Container mk_container

(

Nat0 x1_cwidth_container
,
Nat0 x1_cheight_container

)

;
#ifdef __cplusplus
extern void fpr_container ( ostream & x1 , Container x2 );
#else
extern void fpr_container ( FILE *x1 , Container x2 );
#endif
extern Cvtext_vdmlib cvlines_container ( Container x1 );
/* global variable 'curr_linelen_vdmlib' determines line length */

extern Container chg_cwidth_container ( Container x1 , Nat0 x2 );

extern Container chg_cheight_container ( Container x1 , Nat0 x2 );

extern Container copy1_container ( Container x1 );
extern Block copy1_block ( Block x1 );

extern Block chg_bwidth_block ( Block x1 , Nat0 x2 );

extern Block chg_bheight_block ( Block x1 , Nat0 x2 );

extern Block chg_x_block ( Block x1 , Nat0 x2 );

extern Block chg_y_block ( Block x1 , Nat0 x2 );

extern Cvtext_vdmlib cvlines_block ( Block x1 );
/* global variable 'curr_linelen_vdmlib' determines line length */
#ifdef __cplusplus
extern void fpr_block ( ostream & x1 , Block x2 );
#else
extern void fpr_block ( FILE *x1 , Block x2 );
#endif
extern Block copy_block ( Block x1 );
extern Block mk_block

(

Nat0 x1_bwidth_block
,
Nat0 x1_bheight_block
,
Nat0 x1_x_block
,
Nat0 x1_y_block

)

;
extern void del1_block ( Block x1 );

extern Nat0 s_bwidth_block ( Block x1 );

extern Nat0 s_bheight_block ( Block x1 );

extern Nat0 s_x_block ( Block x1 );

extern Nat0 s_y_block ( Block x1 );

extern void del_block ( Block x1 );
extern void del_confill ( ConFill x1 );
extern ConFill mk1_confill ( Nat0 x1 );
extern Nat0 sel_confill ( ConFill x1 , Nat1 x2 );
extern ConFill tl_confill ( ConFill x1 );
extern void del1_confill ( ConFill x1 );
extern ConFill conc_confill ( ConFill x1 , ConFill x2 );
extern Nat0 hd_confill ( ConFill x1 );
extern ConFill mk_empty_confill ( void );
#ifdef __cplusplus
extern void fpr_confill ( ostream & x1 , ConFill x2 );
#else
extern void fpr_confill ( FILE *x1 , ConFill x2 );
#endif
extern ConFill mkn_confill ( Nat0 x1 , Nat0 x2 );
extern ConFill ovwrt1_confill ( ConFill x1 , Nat1 x2 , Nat0 x3 );
extern Cvtext_vdmlib cvlines_confill ( ConFill x1 );
/* global variable 'curr_linelen_vdmlib' determines line length */
extern Bool is_empty_confill ( ConFill x1 );
extern ConFill appl_confill ( Nat0 x1 , ConFill x2 );
extern ConFill copy1_confill ( ConFill x1 );
extern ConFill appr_confill ( ConFill x1 , Nat0 x2 );
extern Nat0 len_confill ( ConFill x1 );

#define FOR_iter_rep_chromosome(x1,x2) { Iter_rep_chromosome x2##_it = mk_iter_rep_chromosome(x1); while (!is_empty_iter_rep_chromosome(& x2##_it)) { Gen x2 = sel_iter_rep_chromosome(& x2##_it);
#define ENDFOR_iter_rep_chromosome(x2) next_iter_rep_chromosome(& x2##_it); } del_iter_rep_chromosome(x2##_it); }

extern Iter_rep_chromosome mk_iter_rep_chromosome ( Rep_chromosome x1 );
extern void next_iter_rep_chromosome ( Iter_rep_chromosome * x1 );
extern Gen sel_iter_rep_chromosome ( Iter_rep_chromosome * x1 );

#define FOR_iter_rep_confill(x1,x2) { Iter_rep_confill x2##_it = mk_iter_rep_confill(x1); while (!is_empty_iter_rep_confill(& x2##_it)) { Nat0 x2 = sel_iter_rep_confill(& x2##_it);
#define ENDFOR_iter_rep_confill(x2) next_iter_rep_confill(& x2##_it); } del_iter_rep_confill(x2##_it); }

extern Iter_rep_confill mk_iter_rep_confill ( Rep_confill x1 );
extern void next_iter_rep_confill ( Iter_rep_confill * x1 );
extern Nat0 sel_iter_rep_confill ( Iter_rep_confill * x1 );
extern Rep_blocks alloc_rep_blocks ( Nat0 x1 );
extern void free_rep_blocks ( Rep_blocks x1 );

#define ref_rep_blocks(x1) (x1)

#define profile_rep_blocks()

#define FOR_iter_chromosome(x1,x2) { Iter_chromosome x2##_it = mk_iter_chromosome(x1); while (!is_empty_iter_chromosome(& x2##_it)) { Gen x2 = sel_iter_chromosome(& x2##_it);
#define ENDFOR_iter_chromosome(x2) next_iter_chromosome(& x2##_it); } del_iter_chromosome(x2##_it); }

extern Iter_chromosome mk_iter_chromosome ( Chromosome x1 );

#define FOR_iter_confill(x1,x2) { Iter_confill x2##_it = mk_iter_confill(x1); while (!is_empty_iter_confill(& x2##_it)) { Nat0 x2 = sel_iter_confill(& x2##_it);
#define ENDFOR_iter_confill(x2) next_iter_confill(& x2##_it); } del_iter_confill(x2##_it); }

extern Iter_confill mk_iter_confill ( ConFill x1 );

extern Cvtext_vdmlib cvlines1_rep_individual ( Rep_individual x1 );

extern void del_rep_individual ( Rep_individual x1 );

extern Rep_individual chg_rep_chrom_individual_rep_individual ( Rep_individual x1 , Chromosome x2 );

extern Rep_individual chg_rep_fitness_individual_rep_individual ( Rep_individual x1 , Real x2 );

extern Cvtext_vdmlib cvlines_rep_individual ( Rep_individual x1 );
/* global variable 'curr_linelen_vdmlib' determines line length */
extern Rep_individual copy_rep_individual ( Rep_individual x1 );
extern Rep_individual mk_rep_individual

(

Chromosome x1_rep_chrom_individual_rep_individual
,
Real x1_rep_fitness_individual_rep_individual

)

;
extern Container alloc_container ( void );
extern void free_container ( Container x1 );

#define ref_container(x1) (x1)

extern void profile_container ( void );

extern Block alloc_block ( void );
extern void free_block ( Block x1 );

#define ref_block(x1) (x1)

extern void profile_block ( void );

typedef void (* T2_forall_rep_blocks) ( Block y1 ) ;
extern void forall_rep_blocks ( Rep_blocks x1, T2_forall_rep_blocks x2 ) ;
extern Rep_blocks sub_tupd_rep_blocks ( Rep_blocks x1 , Nat1 x2 , Nat0 x3 );

extern Cvtext_vdmlib cvlines1_rep_blocks ( Rep_blocks x1 );

extern void del_rep_blocks ( Rep_blocks x1 );
extern Rep_blocks appr_rep_blocks ( Rep_blocks x1 , Block x2 );
extern Cvtext_vdmlib cvlines_rep_blocks ( Rep_blocks x1 );
/* global variable 'curr_linelen_vdmlib' determines line length */
extern Rep_blocks ovwrt1d_rep_blocks ( Rep_blocks x1 , Nat1 x2 , Block x3 );
extern Rep_blocks copy_rep_blocks ( Rep_blocks x1 );
extern Rep_blocks mknc_rep_blocks ( Block x1 , Nat0 x2 );
extern Rep_blocks conc_rep_blocks ( Rep_blocks x1 , Rep_blocks x2 );
extern Rep_blocks tld_rep_blocks ( Rep_blocks x1 );
extern Rep_blocks mk1_rep_blocks ( Block x1 );
extern void del1_rep_blocks ( Rep_blocks x1 );
extern Individual copy1_individual ( Individual x1 );

extern Individual chg_chrom_individual ( Individual x1 , Chromosome x2 );

extern Individual chg_fitness_individual ( Individual x1 , Real x2 );

extern Cvtext_vdmlib cvlines_individual ( Individual x1 );
/* global variable 'curr_linelen_vdmlib' determines line length */
#ifdef __cplusplus
extern void fpr_individual ( ostream & x1 , Individual x2 );
#else
extern void fpr_individual ( FILE *x1 , Individual x2 );
#endif
extern Individual copy_individual ( Individual x1 );
extern Individual mk_individual

(

Chromosome x1_chrom_individual
,
Real x1_fitness_individual

)

;
extern void del1_individual ( Individual x1 );

extern Chromosome s_chrom_individual ( Individual x1 );

extern Real s_fitness_individual ( Individual x1 );

extern void del_individual ( Individual x1 );
extern Blocks copy_blocks ( Blocks x1 );
extern Nat0 len_blocks ( Blocks x1 );
extern Blocks appr_blocks ( Blocks x1 , Block x2 );
extern Blocks copy1_blocks ( Blocks x1 );
extern Blocks appl_blocks ( Block x1 , Blocks x2 );
extern Bool is_empty_blocks ( Blocks x1 );
extern Cvtext_vdmlib cvlines_blocks ( Blocks x1 );
/* global variable 'curr_linelen_vdmlib' determines line length */
extern Blocks ovwrt1_blocks ( Blocks x1 , Nat1 x2 , Block x3 );
extern Blocks mkn_blocks ( Block x1 , Nat0 x2 );
#ifdef __cplusplus
extern void fpr_blocks ( ostream & x1 , Blocks x2 );
#else
extern void fpr_blocks ( FILE *x1 , Blocks x2 );
#endif
extern Blocks mk_empty_blocks ( void );
extern Block hd_blocks ( Blocks x1 );
extern Blocks conc_blocks ( Blocks x1 , Blocks x2 );
extern void del1_blocks ( Blocks x1 );
extern Blocks tl_blocks ( Blocks x1 );
extern Block sel_blocks ( Blocks x1 , Nat1 x2 );
extern Blocks mk1_blocks ( Block x1 );
extern void del_blocks ( Blocks x1 );

#define FOR_iter_rep_blocks(x1,x2) { Iter_rep_blocks x2##_it = mk_iter_rep_blocks(x1); while (!is_empty_iter_rep_blocks(& x2##_it)) { Block x2 = sel_iter_rep_blocks(& x2##_it);
#define ENDFOR_iter_rep_blocks(x2) next_iter_rep_blocks(& x2##_it); } del_iter_rep_blocks(x2##_it); }

extern Iter_rep_blocks mk_iter_rep_blocks ( Rep_blocks x1 );
extern void next_iter_rep_blocks ( Iter_rep_blocks * x1 );
extern Block sel_iter_rep_blocks ( Iter_rep_blocks * x1 );
extern Rep_individuals alloc_rep_individuals ( Nat0 x1 );
extern void free_rep_individuals ( Rep_individuals x1 );

#define ref_rep_individuals(x1) (x1)

#define profile_rep_individuals()

#define FOR_iter_blocks(x1,x2) { Iter_blocks x2##_it = mk_iter_blocks(x1); while (!is_empty_iter_blocks(& x2##_it)) { Block x2 = sel_iter_blocks(& x2##_it);
#define ENDFOR_iter_blocks(x2) next_iter_blocks(& x2##_it); } del_iter_blocks(x2##_it); }

extern Iter_blocks mk_iter_blocks ( Blocks x1 );
extern Individual alloc_individual ( void );
extern void free_individual ( Individual x1 );

#define ref_individual(x1) (x1)

extern void profile_individual ( void );

typedef void (* T2_forall_rep_individuals) ( Individual y1 ) ;
extern void forall_rep_individuals ( Rep_individuals x1, T2_forall_rep_individuals x2 ) ;
extern Rep_individuals sub_tupd_rep_individuals ( Rep_individuals x1 , Nat1 x2 , Nat0 x3 );

extern Cvtext_vdmlib cvlines1_rep_individuals ( Rep_individuals x1 );

extern void del_rep_individuals ( Rep_individuals x1 );
extern Rep_individuals appr_rep_individuals ( Rep_individuals x1 , Individual x2 );
extern Cvtext_vdmlib cvlines_rep_individuals ( Rep_individuals x1 );
/* global variable 'curr_linelen_vdmlib' determines line length */
extern Rep_individuals ovwrt1d_rep_individuals ( Rep_individuals x1 , Nat1 x2 , Individual x3 );
extern Rep_individuals copy_rep_individuals ( Rep_individuals x1 );
extern Rep_individuals mknc_rep_individuals ( Individual x1 , Nat0 x2 );
extern Rep_individuals conc_rep_individuals ( Rep_individuals x1 , Rep_individuals x2 );
extern Rep_individuals tld_rep_individuals ( Rep_individuals x1 );
extern Rep_individuals mk1_rep_individuals ( Individual x1 );
extern void del1_rep_individuals ( Rep_individuals x1 );
extern Individuals copy_individuals ( Individuals x1 );
extern Nat0 len_individuals ( Individuals x1 );
extern Individuals appr_individuals ( Individuals x1 , Individual x2 );
extern Individuals copy1_individuals ( Individuals x1 );
extern Individuals appl_individuals ( Individual x1 , Individuals x2 );
extern Bool is_empty_individuals ( Individuals x1 );
extern Cvtext_vdmlib cvlines_individuals ( Individuals x1 );
/* global variable 'curr_linelen_vdmlib' determines line length */
extern Individuals ovwrt1_individuals ( Individuals x1 , Nat1 x2 , Individual x3 );
extern Individuals mkn_individuals ( Individual x1 , Nat0 x2 );
#ifdef __cplusplus
extern void fpr_individuals ( ostream & x1 , Individuals x2 );
#else
extern void fpr_individuals ( FILE *x1 , Individuals x2 );
#endif
extern Individuals mk_empty_individuals ( void );
extern Individual hd_individuals ( Individuals x1 );
extern Individuals conc_individuals ( Individuals x1 , Individuals x2 );
extern void del1_individuals ( Individuals x1 );
extern Individuals tl_individuals ( Individuals x1 );
extern Individual sel_individuals ( Individuals x1 , Nat1 x2 );
extern Individuals mk1_individuals ( Individual x1 );
extern void del_individuals ( Individuals x1 );

#define FOR_iter_rep_individuals(x1,x2) { Iter_rep_individuals x2##_it = mk_iter_rep_individuals(x1); while (!is_empty_iter_rep_individuals(& x2##_it)) { Individual x2 = sel_iter_rep_individuals(& x2##_it);
#define ENDFOR_iter_rep_individuals(x2) next_iter_rep_individuals(& x2##_it); } del_iter_rep_individuals(x2##_it); }

extern Iter_rep_individuals mk_iter_rep_individuals ( Rep_individuals x1 );
extern void next_iter_rep_individuals ( Iter_rep_individuals * x1 );
extern Individual sel_iter_rep_individuals ( Iter_rep_individuals * x1 );

#define FOR_iter_individuals(x1,x2) { Iter_individuals x2##_it = mk_iter_individuals(x1); while (!is_empty_iter_individuals(& x2##_it)) { Individual x2 = sel_iter_individuals(& x2##_it);
#define ENDFOR_iter_individuals(x2) next_iter_individuals(& x2##_it); } del_iter_individuals(x2##_it); }

extern Iter_individuals mk_iter_individuals ( Individuals x1 );

extern Cvtext_vdmlib cvlines1_rep_population ( Rep_population x1 );

extern void del_rep_population ( Rep_population x1 );

extern Rep_population chg_rep_ind_population_rep_population ( Rep_population x1 , Individuals x2 );

extern Rep_population chg_rep_popsize_population_rep_population ( Rep_population x1 , Nat1 x2 );

extern Rep_population chg_rep_stringlen_population_rep_population ( Rep_population x1 , Nat1 x2 );

extern Rep_population chg_rep_step_population_rep_population ( Rep_population x1 , Nat1 x2 );

extern Rep_population chg_rep_best_population_rep_population ( Rep_population x1 , Nat1 x2 );

extern Rep_population chg_rep_worst_population_rep_population ( Rep_population x1 , Nat1 x2 );

extern Rep_population chg_rep_bestf_population_rep_population ( Rep_population x1 , Real x2 );

extern Rep_population chg_rep_worstf_population_rep_population ( Rep_population x1 , Real x2 );

extern Rep_population chg_rep_sumfitness_population_rep_population ( Rep_population x1 , Real x2 );

extern Cvtext_vdmlib cvlines_rep_population ( Rep_population x1 );
/* global variable 'curr_linelen_vdmlib' determines line length */
extern Rep_population copy_rep_population ( Rep_population x1 );
extern Rep_population mk_rep_population

(

Individuals x1_rep_ind_population_rep_population
,
Nat1 x1_rep_popsize_population_rep_population
,
Nat1 x1_rep_stringlen_population_rep_population
,
Nat1 x1_rep_step_population_rep_population
,
Nat1 x1_rep_best_population_rep_population
,
Nat1 x1_rep_worst_population_rep_population
,
Real x1_rep_bestf_population_rep_population
,
Real x1_rep_worstf_population_rep_population
,
Real x1_rep_sumfitness_population_rep_population

)

;
extern Population copy_population ( Population x1 );
extern void del_population ( Population x1 );

extern Individuals s_ind_population ( Population x1 );

extern Nat1 s_popsize_population ( Population x1 );

extern Nat1 s_stringlen_population ( Population x1 );

extern Nat1 s_step_population ( Population x1 );

extern Nat1 s_best_population ( Population x1 );

extern Nat1 s_worst_population ( Population x1 );

extern Real s_bestf_population ( Population x1 );

extern Real s_worstf_population ( Population x1 );

extern Real s_sumfitness_population ( Population x1 );

extern void del1_population ( Population x1 );
extern Population mk_population

(

Individuals x1_ind_population
,
Nat1 x1_popsize_population
,
Nat1 x1_stringlen_population
,
Nat1 x1_step_population
,
Nat1 x1_best_population
,
Nat1 x1_worst_population
,
Real x1_bestf_population
,
Real x1_worstf_population
,
Real x1_sumfitness_population

)

;

extern Nat1 Select_population ( Population x1 );

extern Population MakeSumFitness_population ( Population x1 );

#ifdef __cplusplus
extern void fpr_population ( ostream & x1 , Population x2 );
#else
extern void fpr_population ( FILE *x1 , Population x2 );
#endif

extern Population Scaling_population ( Population x1 );

extern Cvtext_vdmlib cvlines_population ( Population x1 );
/* global variable 'curr_linelen_vdmlib' determines line length */

extern Population chg_ind_population ( Population x1 , Individuals x2 );

extern Population chg_popsize_population ( Population x1 , Nat1 x2 );

extern Population chg_stringlen_population ( Population x1 , Nat1 x2 );

extern Population chg_step_population ( Population x1 , Nat1 x2 );

extern Population chg_best_population ( Population x1 , Nat1 x2 );

extern Population chg_worst_population ( Population x1 , Nat1 x2 );

extern Population chg_bestf_population ( Population x1 , Real x2 );

extern Population chg_worstf_population ( Population x1 , Real x2 );

extern Population chg_sumfitness_population ( Population x1 , Real x2 );

extern Population copy1_population ( Population x1 );
extern Population alloc_population ( void );
extern void free_population ( Population x1 );

#define ref_population(x1) (x1)

extern void profile_population ( void );

extern Cvtext_vdmlib cvlines1_rep_ga ( Rep_ga x1 );

extern void del_rep_ga ( Rep_ga x1 );

extern Rep_ga chg_rep_popsize_ga_rep_ga ( Rep_ga x1 , Nat1 x2 );

extern Rep_ga chg_rep_stringlen_ga_rep_ga ( Rep_ga x1 , Nat1 x2 );

extern Rep_ga chg_rep_oldpop_ga_rep_ga ( Rep_ga x1 , Population x2 );

extern Rep_ga chg_rep_newpop_ga_rep_ga ( Rep_ga x1 , Population x2 );

extern Rep_ga chg_rep_pcross_ga_rep_ga ( Rep_ga x1 , Real x2 );

extern Rep_ga chg_rep_pmutation_ga_rep_ga ( Rep_ga x1 , Real x2 );

extern Rep_ga chg_rep_maxchange_ga_rep_ga ( Rep_ga x1 , Real x2 );

extern Rep_ga chg_rep_generation_ga_rep_ga ( Rep_ga x1 , Nat0 x2 );

extern Rep_ga chg_rep_con_ga_rep_ga ( Rep_ga x1 , Container x2 );

extern Rep_ga chg_rep_bl_ga_rep_ga ( Rep_ga x1 , Blocks x2 );

extern Rep_ga chg_rep_containers_ga_rep_ga ( Rep_ga x1 , Nat0 x2 );

extern Cvtext_vdmlib cvlines_rep_ga ( Rep_ga x1 );
/* global variable 'curr_linelen_vdmlib' determines line length */
extern Rep_ga copy_rep_ga ( Rep_ga x1 );
extern Rep_ga mk_rep_ga

(

Nat1 x1_rep_popsize_ga_rep_ga
,
Nat1 x1_rep_stringlen_ga_rep_ga
,
Population x1_rep_oldpop_ga_rep_ga
,
Population x1_rep_newpop_ga_rep_ga
,
Real x1_rep_pcross_ga_rep_ga
,
Real x1_rep_pmutation_ga_rep_ga
,
Real x1_rep_maxchange_ga_rep_ga
,
Nat0 x1_rep_generation_ga_rep_ga
,
Container x1_rep_con_ga_rep_ga

,
Blocks x1_rep_bl_ga_rep_ga
,
Nat0 x1_rep_containers_ga_rep_ga

)

;
extern Ga copy1_ga ( Ga x1 );

extern Ga chg_popsize_ga ( Ga x1 , Nat1 x2 );

extern Ga chg_stringlen_ga ( Ga x1 , Nat1 x2 );

extern Ga chg_oldpop_ga ( Ga x1 , Population x2 );

extern Ga chg_newpop_ga ( Ga x1 , Population x2 );

extern Ga chg_pcross_ga ( Ga x1 , Real x2 );

extern Ga chg_pmutation_ga ( Ga x1 , Real x2 );

extern Ga chg_maxchange_ga ( Ga x1 , Real x2 );

extern Ga chg_generation_ga ( Ga x1 , Nat0 x2 );

extern Ga chg_con_ga ( Ga x1 , Container x2 );

extern Ga chg_bl_ga ( Ga x1 , Blocks x2 );

extern Ga chg_containers_ga ( Ga x1 , Nat0 x2 );

extern Cvtext_vdmlib cvlines_ga ( Ga x1 );
/* global variable 'curr_linelen_vdmlib' determines line length */

extern Ga NextGen_ga ( Ga x1 );

extern Real GetFitness_ga ( Ga x1, Chromosome x2 );

extern Chromosome MakeChrom_ga ( Ga x1, Nat1 x2 );

#ifdef __cplusplus
extern void fpr_ga ( ostream & x1 , Ga x2 );
#else
extern void fpr_ga ( FILE *x1 , Ga x2 );
#endif

extern Chromosome Mutation_ga ( Ga x1, Chromosome x2 );

extern Individual Crossover_ga ( Ga x1, Individual x2, Individual x3, Individual * r2 );

extern Ga Init_ga ( Ga x1, Container x2, Blocks x3, Nat1 x4, Nat1 x5, Nat1 x6, Real x7, Real x8, Real x9 );

extern Ga mk_ga

(

Nat1 x1_popsize_ga
,
Nat1 x1_stringlen_ga
,
Population x1_oldpop_ga
,
Population x1_newpop_ga
,
Real x1_pcross_ga
,
Real x1_pmutation_ga
,
Real x1_maxchange_ga
,
Nat0 x1_generation_ga
,
Container x1_con_ga

,
Blocks x1_bl_ga
,
Nat0 x1_containers_ga

)

;
extern void del1_ga ( Ga x1 );

extern Nat1 s_popsize_ga ( Ga x1 );

extern Nat1 s_stringlen_ga ( Ga x1 );

extern Population s_oldpop_ga ( Ga x1 );

extern Population s_newpop_ga ( Ga x1 );

extern Real s_pcross_ga ( Ga x1 );

extern Real s_pmutation_ga ( Ga x1 );

extern Real s_maxchange_ga ( Ga x1 );

extern Nat0 s_generation_ga ( Ga x1 );

extern Container s_con_ga ( Ga x1 );

extern Blocks s_bl_ga ( Ga x1 );

extern Nat0 s_containers_ga ( Ga x1 );

extern void del_ga ( Ga x1 );
extern Ga alloc_ga ( void );
extern void free_ga ( Ga x1 );

#define ref_ga(x1) (x1)

extern void profile_ga ( void );

/* ------- PHASE4 ------------------ */
#define len_rep_confill(x1) (ref_rep_confill((x1))->f_len)
#define appl_rep_confill(x1,x2) conc_rep_confill(mk1_rep_confill(x1),x2)
#define is_empty_rep_confill(x1) (! (ref_rep_confill((x1))->f_len) )
#define mk_empty_rep_confill() alloc_rep_confill((Nat0)0)
#define hd_rep_confill(x1) sel_rep_confill(x1,(Nat1)1)
extern Nat0 sel_rep_confill ( Rep_confill x1 , Nat1 x2 );

#define len_rep_blocks(x1) (ref_rep_blocks((x1))->f_len)
#define appl_rep_blocks(x1,x2) conc_rep_blocks(mk1_rep_blocks(x1),x2)
#define is_empty_rep_blocks(x1) (! (ref_rep_blocks((x1))->f_len) )
#define mk_empty_rep_blocks() alloc_rep_blocks((Nat0)0)
#define hd_rep_blocks(x1) sel_rep_blocks(x1,(Nat1)1)
extern Block sel_rep_blocks ( Rep_blocks x1 , Nat1 x2 );
#define del1_rep_block(x1)

#define s_rep_bwidth_block_rep_block(x) (x).f_rep_bwidth_block_rep_block

#define s_rep_bheight_block_rep_block(x) (x).f_rep_bheight_block_rep_block

#define s_rep_x_block_rep_block(x) (x).f_rep_x_block_rep_block

#define s_rep_y_block_rep_block(x) (x).f_rep_y_block_rep_block

#define del1_rep_container(x1)

#define s_rep_cwidth_container_rep_container(x) (x).f_rep_cwidth_container_rep_container

#define s_rep_cheight_container_rep_container(x) (x).f_rep_cheight_container_rep_container

#define del1_rep_ga(x1)

#define s_rep_popsize_ga_rep_ga(x) (x).f_rep_popsize_ga_rep_ga

#define s_rep_stringlen_ga_rep_ga(x) (x).f_rep_stringlen_ga_rep_ga

#define s_rep_oldpop_ga_rep_ga(x) (x).f_rep_oldpop_ga_rep_ga

#define s_rep_newpop_ga_rep_ga(x) (x).f_rep_newpop_ga_rep_ga

#define s_rep_pcross_ga_rep_ga(x) (x).f_rep_pcross_ga_rep_ga

#define s_rep_pmutation_ga_rep_ga(x) (x).f_rep_pmutation_ga_rep_ga

#define s_rep_maxchange_ga_rep_ga(x) (x).f_rep_maxchange_ga_rep_ga

#define s_rep_generation_ga_rep_ga(x) (x).f_rep_generation_ga_rep_ga

#define s_rep_con_ga_rep_ga(x) (x).f_rep_con_ga_rep_ga

#define s_rep_bl_ga_rep_ga(x) (x).f_rep_bl_ga_rep_ga

#define s_rep_containers_ga_rep_ga(x) (x).f_rep_containers_ga_rep_ga

#define del1_rep_population(x1)

#define s_rep_ind_population_rep_population(x) (x).f_rep_ind_population_rep_population

#define s_rep_popsize_population_rep_population(x) (x).f_rep_popsize_population_rep_population

#define s_rep_stringlen_population_rep_population(x) (x).f_rep_stringlen_population_rep_population

#define s_rep_step_population_rep_population(x) (x).f_rep_step_population_rep_population

#define s_rep_best_population_rep_population(x) (x).f_rep_best_population_rep_population

#define s_rep_worst_population_rep_population(x) (x).f_rep_worst_population_rep_population

#define s_rep_bestf_population_rep_population(x) (x).f_rep_bestf_population_rep_population

#define s_rep_worstf_population_rep_population(x) (x).f_rep_worstf_population_rep_population

#define s_rep_sumfitness_population_rep_population(x) (x).f_rep_sumfitness_population_rep_population

#define len_rep_individuals(x1) (ref_rep_individuals((x1))->f_len)
#define appl_rep_individuals(x1,x2) conc_rep_individuals(mk1_rep_individuals(x1),x2)
#define is_empty_rep_individuals(x1) (! (ref_rep_individuals((x1))->f_len) )
#define mk_empty_rep_individuals() alloc_rep_individuals((Nat0)0)
#define hd_rep_individuals(x1) sel_rep_individuals(x1,(Nat1)1)
extern Individual sel_rep_individuals ( Rep_individuals x1 , Nat1 x2 );
#define del1_rep_individual(x1)

#define s_rep_chrom_individual_rep_individual(x) (x).f_rep_chrom_individual_rep_individual

#define s_rep_fitness_individual_rep_individual(x) (x).f_rep_fitness_individual_rep_individual

#define mk_empty_rep_chromosome() alloc_rep_chromosome((Nat0)0)
extern Gen sel_rep_chromosome ( Rep_chromosome x1 , Nat1 x2 );
#define appl_rep_chromosome(x1,x2) conc_rep_chromosome(mk1_rep_chromosome(x1),x2)
#define is_empty_rep_chromosome(x1) (! (ref_rep_chromosome((x1))->f_len) )
#define hd_rep_chromosome(x1) sel_rep_chromosome(x1,(Nat1)1)

#define len_rep_chromosome(x1) (ref_rep_chromosome((x1))->f_len)
#define is_empty_iter_confill(x1) is_empty_iter_rep_confill(&((x1)->f_ir))
#define del_iter_confill(x1) del_confill((x1).f_vl)
#define sel_iter_confill(x1) copy_nat0(sel_iter_rep_confill(&((x1)->f_ir)))
#define next_iter_confill(x1) next_iter_rep_confill(&((x1)->f_ir))
#define is_empty_iter_blocks(x1) is_empty_iter_rep_blocks(&((x1)->f_ir))
#define del_iter_blocks(x1) del_blocks((x1).f_vl)
#define sel_iter_blocks(x1) copy_block(sel_iter_rep_blocks(&((x1)->f_ir)))
#define next_iter_blocks(x1) next_iter_rep_blocks(&((x1)->f_ir))
#define is_empty_iter_individuals(x1) is_empty_iter_rep_individuals(&((x1)->f_ir))
#define del_iter_individuals(x1) del_individuals((x1).f_vl)
#define sel_iter_individuals(x1) copy_individual(sel_iter_rep_individuals(&((x1)->f_ir)))
#define next_iter_individuals(x1) next_iter_rep_individuals(&((x1)->f_ir))
#define is_empty_iter_chromosome(x1) is_empty_iter_rep_chromosome(&((x1)->f_ir))
#define del_iter_chromosome(x1) del_chromosome((x1).f_vl)
#define sel_iter_chromosome(x1) copy_gen(sel_iter_rep_chromosome(&((x1)->f_ir)))
#define next_iter_chromosome(x1) next_iter_rep_chromosome(&((x1)->f_ir))
#define del_iter_rep_confill(x1)
#define is_empty_iter_rep_confill(x1) ((x1)->f_curser == (x1)->f_array->f_len)
#define del_iter_rep_blocks(x1)
#define is_empty_iter_rep_blocks(x1) ((x1)->f_curser == (x1)->f_array->f_len)
#define del_iter_rep_individuals(x1)
#define is_empty_iter_rep_individuals(x1) ((x1)->f_curser == (x1)->f_array->f_len)
#define del_iter_rep_chromosome(x1)
#define is_empty_iter_rep_chromosome(x1) ((x1)->f_curser == (x1)->f_array->f_len)

#endif
