#ifndef CPP_header_knaps
#define CPP_header_knaps
/* ------- PHASE1 ------------------ */

#include "knaps.h"

/*
module generated from VDM Class Library
$Revision: 1.101 $
$Date: 1996/09/19 09:25:46 $
*/
class VDMLIB;
class BOOL;
class NILETC;
class STDLIB;
class REAL;
class NAT1;
class NAT0;
class INTG;
class CHAR;

#define GEN NAT1

class STR;
class CHROMOSOME;
class CONTAINER;
class BLOCK;
class CONFILL;
class ITER_CHROMOSOME;
class ITER_CONFILL;
class INDIVIDUAL;
class BLOCKS;
class ITER_BLOCKS;
class INDIVIDUALS;
class ITER_INDIVIDUALS;
class POPULATION;
class GA;

/* ------- PHASE2 ------------------ */
class VDMLIB {
};
class BOOL {
public:
Bool data;
BOOL() {}
BOOL (int x1) { data = (Bool)x1; }
BOOL & operator=(int x1) { data = (Bool)x1; return *this; }
BOOL (const BOOL & x1) { data = x1.data; }
BOOL & operator=(const BOOL & x1) { data = x1.data; return *this; }

operator int() const { return (int)data; }

Bool cv_bool() const { return data; }

inline BOOL not () const
;

inline BOOL operator ! () const
;

inline BOOL is_gr (const BOOL & x2) const
;

inline BOOL operator > (const BOOL & x2) const
;

inline BOOL xor (const BOOL & x2)
;

inline BOOL & operator ^= (const BOOL & x2)
;

inline BOOL operator ^ (const BOOL & x2)
;

inline BOOL and (const BOOL & x2)
;

inline BOOL & operator &= (const BOOL & x2)
;

inline BOOL operator & (const BOOL & x2)
;

inline BOOL is_eq (const BOOL & x2) const
;

inline BOOL operator == (const BOOL & x2) const
;

inline BOOL operator != (const BOOL & x2) const
;

inline BOOL is_ge (const BOOL & x2) const
;

inline BOOL operator >= (const BOOL & x2) const
;

inline BOOL or (const BOOL & x2)
;

inline BOOL & operator |= (const BOOL & x2)
;

inline BOOL operator | (const BOOL & x2)
;

};
class NILETC {
};

#ifndef STDLIB_CL
#define STDLIB_CL
class STDLIB {

};
#endif
class REAL {
public:
Real data;
REAL () {}
REAL (Real x1) { data = x1; }
REAL & operator=(Real x1) { data = x1; return *this; }
REAL (const REAL & x1) { data = x1.data; }
REAL & operator=(const REAL & x1) { data = x1.data; return *this; }

Real cv_real() const { return data; }

inline REAL copy () const
;
inline void set_print_format (char * x1) const
;

inline void set_print_format () const
;

inline REAL minus (const REAL & x2) const
;

inline REAL & operator -= (const REAL & x2)
;

inline REAL operator - (const REAL & x2) const
;

inline REAL div (const REAL & x2) const
;

inline REAL & operator /= (const REAL & x2)
;

inline REAL operator / (const REAL & x2) const
;

inline BOOL is_gr (const REAL & x2) const
;

inline BOOL operator > (const REAL & x2) const
;

inline BOOL is_le (const REAL & x2) const
;

inline BOOL operator <= (const REAL & x2) const
;

inline REAL succ ()
;

inline REAL & operator ++ ()
;

inline REAL operator ++ (int)
;

inline void fpr (ostream & x1) const
;
inline friend ostream & operator << (ostream & x1, const REAL & x2)
;

/* NOTE: Do not generate 'fpr' together with 'fprint' for C++ */
/* since both will be mapped to the operator '<<' !!! */

inline REAL plus (const REAL & x2) const
;

inline REAL & operator += (const REAL & x2)
;

inline REAL operator + (const REAL & x2) const
;

inline REAL times (const REAL & x2) const
;

inline REAL & operator *= (const REAL & x2)
;

inline REAL operator * (const REAL & x2) const
;

inline BOOL is_ge (const REAL & x2) const
;

inline BOOL operator >= (const REAL & x2) const
;

inline BOOL is_lt (const REAL & x2) const
;

inline BOOL operator < (const REAL & x2) const
;

inline BOOL is_eq (const REAL & x2) const
;

inline BOOL operator == (const REAL & x2) const
;

inline BOOL operator != (const REAL & x2) const
;

inline BOOL operator ! () const
;

inline REAL pred ()
;

inline REAL & operator -- ()
;

inline REAL operator -- (int)
;

inline void del ()
;

};
class NAT1 {
public:
Nat1 data;
NAT1 () {}
NAT1 (Nat1 x1) { data = x1; }
NAT1 & operator=(Nat1 x1) { data = x1; return *this; }
NAT1 (const NAT1 & x1) { data = x1.data; }
NAT1 & operator=(const NAT1 & x1) { data = x1.data; return *this; }

Nat1 cv_nat1() const { return data; }

NAT1 (const NAT0 & x1);

operator NAT0 () const;

inline void set_print_format (char * x1) const
;

inline void set_print_format () const
;

inline NAT1 pred ()
;

inline NAT1 & operator -- ()
;

inline NAT1 operator -- (int)
;

inline BOOL is_eq (const NAT1 & x2) const
;

inline BOOL operator == (const NAT1 & x2) const
;

inline BOOL operator != (const NAT1 & x2) const
;

inline BOOL operator ! () const
;

inline BOOL is_lt (const NAT1 & x2) const
;

inline BOOL operator < (const NAT1 & x2) const
;

inline BOOL is_ge (const NAT1 & x2) const
;

inline BOOL operator >= (const NAT1 & x2) const
;

inline NAT1 times (const NAT1 & x2) const
;

inline NAT1 & operator *= (const NAT1 & x2)
;

inline NAT1 operator * (const NAT1 & x2) const
;

inline NAT1 plus (const NAT1 & x2) const
;

inline NAT1 & operator += (const NAT1 & x2)
;

inline NAT1 operator + (const NAT1 & x2) const
;

inline void del ()
;

inline NAT1 copy () const
;

inline NAT1 succ ()
;

inline NAT1 & operator ++ ()
;

inline NAT1 operator ++ (int)
;

inline NAT1 mod (const NAT1 & x2) const
;

inline NAT1 & operator %= (const NAT1 & x2)
;

inline NAT1 operator % (const NAT1 & x2) const
;

inline BOOL is_le (const NAT1 & x2) const
;

inline BOOL operator <= (const NAT1 & x2) const
;

inline BOOL is_gr (const NAT1 & x2) const
;

inline BOOL operator > (const NAT1 & x2) const
;

inline NAT1 div (const NAT1 & x2) const
;

inline NAT1 & operator /= (const NAT1 & x2)
;

inline NAT1 operator / (const NAT1 & x2) const
;

inline NAT1 minus (const NAT1 & x2) const
;

inline NAT1 & operator -= (const NAT1 & x2)
;

inline NAT1 operator - (const NAT1 & x2) const
;

};
class NAT0 {
public:
Nat0 data;
NAT0 () {}
NAT0 (Nat0 x1) { data = x1; }
NAT0 & operator=(Nat0 x1) { data = x1; return *this; }
NAT0 (const NAT0 & x1) { data = x1.data; }
NAT0 & operator=(const NAT0 & x1) { data = x1.data; return *this; }

Nat0 cv_nat0() const { return data; }

NAT0 (const INTG & x1);

inline void set_print_format (char * x1) const
;

inline void set_print_format () const
;

inline NAT0 pred ()
;

inline NAT0 & operator -- ()
;

inline NAT0 operator -- (int)
;

inline BOOL is_eq (const NAT0 & x2) const
;

inline BOOL operator == (const NAT0 & x2) const
;

inline BOOL operator != (const NAT0 & x2) const
;

inline BOOL operator ! () const
;

inline BOOL is_lt (const NAT0 & x2) const
;

inline BOOL operator < (const NAT0 & x2) const
;

inline BOOL is_ge (const NAT0 & x2) const
;

inline BOOL operator >= (const NAT0 & x2) const
;

inline NAT0 times (const NAT0 & x2) const
;

inline NAT0 & operator *= (const NAT0 & x2)
;

inline NAT0 operator * (const NAT0 & x2) const
;

inline NAT0 plus (const NAT0 & x2) const
;

inline NAT0 & operator += (const NAT0 & x2)
;

inline NAT0 operator + (const NAT0 & x2) const
;

inline void del ()
;

inline NAT0 copy () const
;

inline NAT0 succ ()
;

inline NAT0 & operator ++ ()
;

inline NAT0 operator ++ (int)
;

inline NAT0 mod (const NAT0 & x2) const
;

inline NAT0 & operator %= (const NAT0 & x2)
;

inline NAT0 operator % (const NAT0 & x2) const
;

inline BOOL is_le (const NAT0 & x2) const
;

inline BOOL operator <= (const NAT0 & x2) const
;

inline BOOL is_gr (const NAT0 & x2) const
;

inline BOOL operator > (const NAT0 & x2) const
;

inline NAT0 div (const NAT0 & x2) const
;

inline NAT0 & operator /= (const NAT0 & x2)
;

inline NAT0 operator / (const NAT0 & x2) const
;

inline NAT0 minus (const NAT0 & x2) const
;

inline NAT0 & operator -= (const NAT0 & x2)
;

inline NAT0 operator - (const NAT0 & x2) const
;

};
class INTG {
public:
Intg data;
INTG () {}
INTG (Intg x1) { data = x1; }
INTG & operator=(Intg x1) { data = x1; return *this; }
INTG (const INTG & x1) { data = x1.data; }
INTG & operator=(const INTG & x1) { data = x1.data; return *this; }

Intg cv_intg() const { return data; }

INTG (const NAT0 & x1);

inline INTG pred ()
;

inline INTG & operator -- ()
;

inline INTG operator -- (int)
;

inline BOOL is_eq (const INTG & x2) const
;

inline BOOL operator == (const INTG & x2) const
;

inline BOOL operator != (const INTG & x2) const
;

inline BOOL operator ! () const
;

inline BOOL is_lt (const INTG & x2) const
;

inline BOOL operator < (const INTG & x2) const
;

inline BOOL is_ge (const INTG & x2) const
;

inline BOOL operator >= (const INTG & x2) const
;

inline INTG times (const INTG & x2) const
;

inline INTG & operator *= (const INTG & x2)
;

inline INTG operator * (const INTG & x2) const
;

inline INTG plus (const INTG & x2) const
;

inline INTG & operator += (const INTG & x2)
;

inline INTG operator + (const INTG & x2) const
;

inline INTG succ ()
;

inline INTG & operator ++ ()
;

inline INTG operator ++ (int)
;

inline INTG mod (const INTG & x2) const
;

inline INTG & operator %= (const INTG & x2)
;

inline INTG operator % (const INTG & x2) const
;

inline BOOL is_le (const INTG & x2) const
;

inline BOOL operator <= (const INTG & x2) const
;

inline BOOL is_gr (const INTG & x2) const
;

inline BOOL operator > (const INTG & x2) const
;

inline INTG div (const INTG & x2) const
;

inline INTG & operator /= (const INTG & x2)
;

inline INTG operator / (const INTG & x2) const
;

inline INTG minus (const INTG & x2) const
;

inline INTG & operator -= (const INTG & x2)
;

inline INTG operator - (const INTG & x2) const
;

};
class CHAR {
public:
Char data;
CHAR () {}
CHAR (Char x1) { data = x1; }
CHAR & operator=(Char x1) { data = x1; return *this; }
CHAR (const CHAR & x1) { data = x1.data; }
CHAR & operator=(const CHAR & x1) { data = x1.data; return *this; }

Char cv_char() const { return data; }

CHAR (const NAT0 & x1);

operator NAT0 () const;

inline CHAR copy () const
;

inline CHAR pred ()
;

inline CHAR & operator -- ()
;

inline CHAR operator -- (int)
;

inline BOOL is_eq (const CHAR & x2) const
;

inline BOOL operator == (const CHAR & x2) const
;

inline BOOL operator != (const CHAR & x2) const
;

inline BOOL operator ! () const
;

inline BOOL is_lt (const CHAR & x2) const
;

inline BOOL operator < (const CHAR & x2) const
;

inline BOOL is_ge (const CHAR & x2) const
;

inline BOOL operator >= (const CHAR & x2) const
;

inline CHAR times (const CHAR & x2) const
;

inline CHAR & operator *= (const CHAR & x2)
;

inline CHAR operator * (const CHAR & x2) const
;

inline CHAR plus (const CHAR & x2) const
;

inline CHAR & operator += (const CHAR & x2)
;

inline CHAR operator + (const CHAR & x2) const
;

inline CHAR succ ()
;

inline CHAR & operator ++ ()
;

inline CHAR operator ++ (int)
;

inline CHAR mod (const CHAR & x2) const
;

inline CHAR & operator %= (const CHAR & x2)
;

inline CHAR operator % (const CHAR & x2) const
;

inline BOOL is_le (const CHAR & x2) const
;

inline BOOL operator <= (const CHAR & x2) const
;

inline BOOL is_gr (const CHAR & x2) const
;

inline BOOL operator > (const CHAR & x2) const
;

inline CHAR div (const CHAR & x2) const
;

inline CHAR & operator /= (const CHAR & x2)
;

inline CHAR operator / (const CHAR & x2) const
;

inline CHAR minus (const CHAR & x2) const
;

inline CHAR & operator -= (const CHAR & x2)
;

inline CHAR operator - (const CHAR & x2) const
;

inline void del ()
;

};

class STR {
public:
Str data;

STR()
{
data = 0;
/* == non valid handle */
}

~STR() { del_str(data); }

STR(const STR & x1)
{
check_handle_str(x1.data);
data = x1.data;
data->f_rc++;
}

STR(const Str &x1)
{
check_handle_str(x1);
data = x1;

}

STR & operator=(const STR & x1)
{
check_handle_str(x1.data);
(x1.data)->f_rc++;
if (data!=0) del_str(data);
data = x1.data;
return *this;
}

Str cv_str() const
{
check_handle_str(data);
data->f_rc++;
return data;
}

inline NAT0 len () const
;
inline NAT0 index (const CHAR & x2) const
;
inline CHAR hd () const
;

inline STR & conc (const STR & x2)
;

inline STR & operator += (const STR & x2)
;

inline STR operator + (const STR & x2) const
;

inline CHAR sel (const NAT1 & x2) const
;
 CHAR operator [] (const NAT1 & x2) const
;
inline void cpc (char * x2) const
;
inline STR (char * x1)
;

/* === Member function 'del' not required for automem implementations === */

/* === Member function 'copy' not required for automem implementations === */
inline STR & ovwrt1 (const NAT1 & x2, const CHAR & x3)
;
inline STR (const CHAR & x1, const NAT0 & x2)
;
};
class CHROMOSOME {
public:
Chromosome data;

CHROMOSOME()
{
data = 0;
/* == non valid handle */
}

~CHROMOSOME() { del_chromosome(data); }

CHROMOSOME(const CHROMOSOME & x1)
{
check_handle_chromosome(x1.data);
data = x1.data;
data->f_rc++;
}

CHROMOSOME(const Chromosome &x1)
{
check_handle_chromosome(x1);
data = x1;

}

CHROMOSOME & operator=(const CHROMOSOME & x1)
{
check_handle_chromosome(x1.data);
(x1.data)->f_rc++;
if (data!=0) del_chromosome(data);
data = x1.data;
return *this;
}

Chromosome cv_chromosome() const
{
check_handle_chromosome(data);
data->f_rc++;
return data;
}

/* === Member function 'copy' not required for automem implementations === */
inline NAT0 len () const
;

inline CHROMOSOME & appr (const GEN & x2)
;

inline CHROMOSOME & operator += (const GEN & x2)
;

inline CHROMOSOME operator + (const GEN & x2) const
;

/* Member function 'copy1' not required for automem implementations */

inline CHROMOSOME & appl (const GEN & x1)
;
inline friend CHROMOSOME operator + (const GEN & x1, CHROMOSOME & x2)
;

inline BOOL is_empty () const
;

inline BOOL operator ! () const
;

NAT0 Position (const NAT1 & x2)  ;

inline CHROMOSOME & ovwrt1 (const NAT1 & x2, const GEN & x3)
;
inline CHROMOSOME & rmv1 (const NAT1 & x2)
;
inline CHROMOSOME (const GEN & x1, const NAT0 & x2)
;
inline void fpr (ostream & x1) const
;
inline friend ostream & operator << (ostream & x1, const CHROMOSOME & x2)
;

/* NOTE: Do not generate 'fpr' together with 'fprint' for C++ */
/* since both will be mapped to the operator '<<' !!! */

CHROMOSOME & Exchange (const NAT1 & x2, const NAT1 & x3)  ;

inline CHROMOSOME (const NILETC & x1)
;
inline GEN hd () const
;

inline CHROMOSOME & conc (const CHROMOSOME & x2)
;

inline CHROMOSOME & operator += (const CHROMOSOME & x2)
;

inline CHROMOSOME operator + (const CHROMOSOME & x2) const
;

/* Member function 'del1' not required for automem implementations */

inline CHROMOSOME & tl ()
;
inline GEN sel (const NAT1 & x2) const
;
 GEN operator [] (const NAT1 & x2) const
;
inline CHROMOSOME (const GEN & x1)
;

/* === Member function 'del' not required for automem implementations === */

};
class CONTAINER {
public:
Container data;

CONTAINER()
{
data = 0;
/* == non valid handle */
}

~CONTAINER()
{
del_container(data);
}

CONTAINER(const CONTAINER & x1)
{
check_handle_container(x1.data);
data = x1.data;
data->f_rc++;
}

CONTAINER(const Container &x1)
{
check_handle_container(x1);
data = x1;
}

CONTAINER & operator = (const CONTAINER & x1)
{
check_handle_container(x1.data);
(x1.data)->f_rc++;
if (data!=0) del_container(data);
data = x1.data;
return *this;
}

Container cv_container() const
{
check_handle_container(data);
data->f_rc++;
return data;
}

/* === Member function 'copy' not required for automem implementations === */

/* === Member function 'del' not required for automem implementations === */

inline NAT0 cwidth () const
;

inline NAT0 cheight () const
;

/* Member function 'del1' not required for automem implementations */

inline CONTAINER
(

const NAT0 & x_cwidth_container
,
const NAT0 & x_cheight_container

)
;
inline void fpr (ostream & x1) const
;
inline friend ostream & operator << (ostream & x1, const CONTAINER & x2)
;

/* NOTE: Do not generate 'fpr' together with 'fprint' for C++ */
/* since both will be mapped to the operator '<<' !!! */

inline CONTAINER & chg_cwidth (const NAT0 & x2)
;

inline CONTAINER & chg_cheight (const NAT0 & x2)
;

/* Member function 'copy1' not required for automem implementations */

};
class BLOCK {
public:
Block data;

BLOCK()
{
data = 0;
/* == non valid handle */
}

~BLOCK()
{
del_block(data);
}

BLOCK(const BLOCK & x1)
{
check_handle_block(x1.data);
data = x1.data;
data->f_rc++;
}

BLOCK(const Block &x1)
{
check_handle_block(x1);
data = x1;
}

BLOCK & operator = (const BLOCK & x1)
{
check_handle_block(x1.data);
(x1.data)->f_rc++;
if (data!=0) del_block(data);
data = x1.data;
return *this;
}

Block cv_block() const
{
check_handle_block(data);
data->f_rc++;
return data;
}

/* Member function 'copy1' not required for automem implementations */

inline BLOCK & chg_bwidth (const NAT0 & x2)
;

inline BLOCK & chg_bheight (const NAT0 & x2)
;

inline BLOCK & chg_x (const NAT0 & x2)
;

inline BLOCK & chg_y (const NAT0 & x2)
;

inline void fpr (ostream & x1) const
;
inline friend ostream & operator << (ostream & x1, const BLOCK & x2)
;

/* NOTE: Do not generate 'fpr' together with 'fprint' for C++ */
/* since both will be mapped to the operator '<<' !!! */

/* === Member function 'copy' not required for automem implementations === */
inline BLOCK
(

const NAT0 & x_bwidth_block
,
const NAT0 & x_bheight_block
,
const NAT0 & x_x_block
,
const NAT0 & x_y_block

)
;

/* Member function 'del1' not required for automem implementations */

inline NAT0 bwidth () const
;

inline NAT0 bheight () const
;

inline NAT0 x () const
;

inline NAT0 y () const
;

/* === Member function 'del' not required for automem implementations === */

};
class CONFILL {
public:
ConFill data;

CONFILL()
{
data = 0;
/* == non valid handle */
}

~CONFILL() { del_confill(data); }

CONFILL(const CONFILL & x1)
{
check_handle_confill(x1.data);
data = x1.data;
data->f_rc++;
}

CONFILL(const ConFill &x1)
{
check_handle_confill(x1);
data = x1;

}

CONFILL & operator=(const CONFILL & x1)
{
check_handle_confill(x1.data);
(x1.data)->f_rc++;
if (data!=0) del_confill(data);
data = x1.data;
return *this;
}

ConFill cv_confill() const
{
check_handle_confill(data);
data->f_rc++;
return data;
}

/* === Member function 'del' not required for automem implementations === */

inline CONFILL (const NAT0 & x1)
;

inline NAT0 sel (const NAT1 & x2) const
;
 NAT0 operator [] (const NAT1 & x2) const
;
inline CONFILL & tl ()
;

/* Member function 'del1' not required for automem implementations */

inline CONFILL & conc (const CONFILL & x2)
;

inline CONFILL & operator += (const CONFILL & x2)
;

inline CONFILL operator + (const CONFILL & x2) const
;

inline NAT0 hd () const
;
inline CONFILL (const NILETC & x1)
;
inline void fpr (ostream & x1) const
;
inline friend ostream & operator << (ostream & x1, const CONFILL & x2)
;

/* NOTE: Do not generate 'fpr' together with 'fprint' for C++ */
/* since both will be mapped to the operator '<<' !!! */

inline CONFILL (const NAT0 & x1, const NAT0 & x2)
;
inline CONFILL & ovwrt1 (const NAT1 & x2, const NAT0 & x3)
;

inline BOOL is_empty () const
;

inline BOOL operator ! () const
;

inline CONFILL & appl (const NAT0 & x1)
;
inline friend CONFILL operator + (const NAT0 & x1, CONFILL & x2)
;

/* Member function 'copy1' not required for automem implementations */

inline CONFILL & appr (const NAT0 & x2)
;

inline CONFILL & operator += (const NAT0 & x2)
;

inline CONFILL operator + (const NAT0 & x2) const
;

inline NAT0 len () const
;
};
class ITER_CHROMOSOME {
public:
Iter_chromosome data;
~ITER_CHROMOSOME() { del_iter_chromosome(data); }
inline BOOL is_empty ()
;

inline BOOL operator ! ()
;

/* === Member function 'del' not required for automem implementations === */

inline ITER_CHROMOSOME (CHROMOSOME x1)
;
inline GEN sel ()
;
inline void next ()
;

inline void operator ++ ()
;

inline void operator ++ (int)
;
};
class ITER_CONFILL {
public:
Iter_confill data;
~ITER_CONFILL() { del_iter_confill(data); }
inline BOOL is_empty ()
;

inline BOOL operator ! ()
;

/* === Member function 'del' not required for automem implementations === */

inline ITER_CONFILL (CONFILL x1)
;
inline NAT0 sel ()
;
inline void next ()
;

inline void operator ++ ()
;

inline void operator ++ (int)
;
};
class INDIVIDUAL {
public:
Individual data;

INDIVIDUAL()
{
data = 0;
/* == non valid handle */
}

~INDIVIDUAL()
{
del_individual(data);
}

INDIVIDUAL(const INDIVIDUAL & x1)
{
check_handle_individual(x1.data);
data = x1.data;
data->f_rc++;
}

INDIVIDUAL(const Individual &x1)
{
check_handle_individual(x1);
data = x1;
}

INDIVIDUAL & operator = (const INDIVIDUAL & x1)
{
check_handle_individual(x1.data);
(x1.data)->f_rc++;
if (data!=0) del_individual(data);
data = x1.data;
return *this;
}

Individual cv_individual() const
{
check_handle_individual(data);
data->f_rc++;
return data;
}

/* Member function 'copy1' not required for automem implementations */

inline INDIVIDUAL & chg_chrom (const CHROMOSOME & x2)
;

inline INDIVIDUAL & chg_fitness (const REAL & x2)
;

inline void fpr (ostream & x1) const
;
inline friend ostream & operator << (ostream & x1, const INDIVIDUAL & x2)
;

/* NOTE: Do not generate 'fpr' together with 'fprint' for C++ */
/* since both will be mapped to the operator '<<' !!! */

/* === Member function 'copy' not required for automem implementations === */
inline INDIVIDUAL
(

const CHROMOSOME & x_chrom_individual
,
const REAL & x_fitness_individual

)
;

/* Member function 'del1' not required for automem implementations */

inline CHROMOSOME chrom () const
;

inline REAL fitness () const
;

/* === Member function 'del' not required for automem implementations === */

};
class BLOCKS {
public:
Blocks data;

BLOCKS()
{
data = 0;
/* == non valid handle */
}

~BLOCKS() { del_blocks(data); }

BLOCKS(const BLOCKS & x1)
{
check_handle_blocks(x1.data);
data = x1.data;
data->f_rc++;
}

BLOCKS(const Blocks &x1)
{
check_handle_blocks(x1);
data = x1;

}

BLOCKS & operator=(const BLOCKS & x1)
{
check_handle_blocks(x1.data);
(x1.data)->f_rc++;
if (data!=0) del_blocks(data);
data = x1.data;
return *this;
}

Blocks cv_blocks() const
{
check_handle_blocks(data);
data->f_rc++;
return data;
}

/* === Member function 'copy' not required for automem implementations === */
inline NAT0 len () const
;

inline BLOCKS & appr (const BLOCK & x2)
;

inline BLOCKS & operator += (const BLOCK & x2)
;

inline BLOCKS operator + (const BLOCK & x2) const
;

/* Member function 'copy1' not required for automem implementations */

inline BLOCKS & appl (const BLOCK & x1)
;
inline friend BLOCKS operator + (const BLOCK & x1, BLOCKS & x2)
;

inline BOOL is_empty () const
;

inline BOOL operator ! () const
;

inline BLOCKS & ovwrt1 (const NAT1 & x2, const BLOCK & x3)
;
inline BLOCKS (const BLOCK & x1, const NAT0 & x2)
;
inline void fpr (ostream & x1) const
;
inline friend ostream & operator << (ostream & x1, const BLOCKS & x2)
;

/* NOTE: Do not generate 'fpr' together with 'fprint' for C++ */
/* since both will be mapped to the operator '<<' !!! */

inline BLOCKS (const NILETC & x1)
;
inline BLOCK hd () const
;

inline BLOCKS & conc (const BLOCKS & x2)
;

inline BLOCKS & operator += (const BLOCKS & x2)
;

inline BLOCKS operator + (const BLOCKS & x2) const
;

/* Member function 'del1' not required for automem implementations */

inline BLOCKS & tl ()
;
inline BLOCK sel (const NAT1 & x2) const
;
 BLOCK operator [] (const NAT1 & x2) const
;
inline BLOCKS (const BLOCK & x1)
;

/* === Member function 'del' not required for automem implementations === */

};
class ITER_BLOCKS {
public:
Iter_blocks data;
~ITER_BLOCKS() { del_iter_blocks(data); }
inline BOOL is_empty ()
;

inline BOOL operator ! ()
;

/* === Member function 'del' not required for automem implementations === */

inline ITER_BLOCKS (BLOCKS x1)
;
inline BLOCK sel ()
;
inline void next ()
;

inline void operator ++ ()
;

inline void operator ++ (int)
;
};
class INDIVIDUALS {
public:
Individuals data;

INDIVIDUALS()
{
data = 0;
/* == non valid handle */
}

~INDIVIDUALS() { del_individuals(data); }

INDIVIDUALS(const INDIVIDUALS & x1)
{
check_handle_individuals(x1.data);
data = x1.data;
data->f_rc++;
}

INDIVIDUALS(const Individuals &x1)
{
check_handle_individuals(x1);
data = x1;

}

INDIVIDUALS & operator=(const INDIVIDUALS & x1)
{
check_handle_individuals(x1.data);
(x1.data)->f_rc++;
if (data!=0) del_individuals(data);
data = x1.data;
return *this;
}

Individuals cv_individuals() const
{
check_handle_individuals(data);
data->f_rc++;
return data;
}

/* === Member function 'copy' not required for automem implementations === */
inline NAT0 len () const
;

inline INDIVIDUALS & appr (const INDIVIDUAL & x2)
;

inline INDIVIDUALS & operator += (const INDIVIDUAL & x2)
;

inline INDIVIDUALS operator + (const INDIVIDUAL & x2) const
;

/* Member function 'copy1' not required for automem implementations */

inline INDIVIDUALS & appl (const INDIVIDUAL & x1)
;
inline friend INDIVIDUALS operator + (const INDIVIDUAL & x1, INDIVIDUALS & x2)
;

inline BOOL is_empty () const
;

inline BOOL operator ! () const
;

inline INDIVIDUALS & ovwrt1 (const NAT1 & x2, const INDIVIDUAL & x3)
;
inline INDIVIDUALS (const INDIVIDUAL & x1, const NAT0 & x2)
;
inline void fpr (ostream & x1) const
;
inline friend ostream & operator << (ostream & x1, const INDIVIDUALS & x2)
;

/* NOTE: Do not generate 'fpr' together with 'fprint' for C++ */
/* since both will be mapped to the operator '<<' !!! */

inline INDIVIDUALS (const NILETC & x1)
;
inline INDIVIDUAL hd () const
;

inline INDIVIDUALS & conc (const INDIVIDUALS & x2)
;

inline INDIVIDUALS & operator += (const INDIVIDUALS & x2)
;

inline INDIVIDUALS operator + (const INDIVIDUALS & x2) const
;

/* Member function 'del1' not required for automem implementations */

inline INDIVIDUALS & tl ()
;
inline INDIVIDUAL sel (const NAT1 & x2) const
;
 INDIVIDUAL operator [] (const NAT1 & x2) const
;
inline INDIVIDUALS (const INDIVIDUAL & x1)
;

/* === Member function 'del' not required for automem implementations === */

};
class ITER_INDIVIDUALS {
public:
Iter_individuals data;
~ITER_INDIVIDUALS() { del_iter_individuals(data); }
inline BOOL is_empty ()
;

inline BOOL operator ! ()
;

/* === Member function 'del' not required for automem implementations === */

inline ITER_INDIVIDUALS (INDIVIDUALS x1)
;
inline INDIVIDUAL sel ()
;
inline void next ()
;

inline void operator ++ ()
;

inline void operator ++ (int)
;
};
class POPULATION {
public:
Population data;

POPULATION()
{
data = 0;
/* == non valid handle */
}

~POPULATION()
{
del_population(data);
}

POPULATION(const POPULATION & x1)
{
check_handle_population(x1.data);
data = x1.data;
data->f_rc++;
}

POPULATION(const Population &x1)
{
check_handle_population(x1);
data = x1;
}

POPULATION & operator = (const POPULATION & x1)
{
check_handle_population(x1.data);
(x1.data)->f_rc++;
if (data!=0) del_population(data);
data = x1.data;
return *this;
}

Population cv_population() const
{
check_handle_population(data);
data->f_rc++;
return data;
}

/* === Member function 'copy' not required for automem implementations === */

/* === Member function 'del' not required for automem implementations === */

inline INDIVIDUALS ind () const
;

inline NAT1 popsize () const
;

inline NAT1 stringlen () const
;

inline NAT1 step () const
;

inline NAT1 best () const
;

inline NAT1 worst () const
;

inline REAL bestf () const
;

inline REAL worstf () const
;

inline REAL sumfitness () const
;

/* Member function 'del1' not required for automem implementations */

inline POPULATION
(

const INDIVIDUALS & x_ind_population
,
const NAT1 & x_popsize_population
,
const NAT1 & x_stringlen_population
,
const NAT1 & x_step_population
,
const NAT1 & x_best_population
,
const NAT1 & x_worst_population
,
const REAL & x_bestf_population
,
const REAL & x_worstf_population
,
const REAL & x_sumfitness_population

)
;

NAT1 Select ()  ;

POPULATION & MakeSumFitness ()  ;

inline void fpr (ostream & x1) const
;
inline friend ostream & operator << (ostream & x1, const POPULATION & x2)
;

/* NOTE: Do not generate 'fpr' together with 'fprint' for C++ */
/* since both will be mapped to the operator '<<' !!! */

POPULATION & Scaling ()  ;

inline POPULATION & chg_ind (const INDIVIDUALS & x2)
;

inline POPULATION & chg_popsize (const NAT1 & x2)
;

inline POPULATION & chg_stringlen (const NAT1 & x2)
;

inline POPULATION & chg_step (const NAT1 & x2)
;

inline POPULATION & chg_best (const NAT1 & x2)
;

inline POPULATION & chg_worst (const NAT1 & x2)
;

inline POPULATION & chg_bestf (const REAL & x2)
;

inline POPULATION & chg_worstf (const REAL & x2)
;

inline POPULATION & chg_sumfitness (const REAL & x2)
;

/* Member function 'copy1' not required for automem implementations */

};
class GA {
public:
Ga data;

GA()
{
data = 0;
/* == non valid handle */
}

~GA()
{
del_ga(data);
}

GA(const GA & x1)
{
check_handle_ga(x1.data);
data = x1.data;
data->f_rc++;
}

GA(const Ga &x1)
{
check_handle_ga(x1);
data = x1;
}

GA & operator = (const GA & x1)
{
check_handle_ga(x1.data);
(x1.data)->f_rc++;
if (data!=0) del_ga(data);
data = x1.data;
return *this;
}

Ga cv_ga() const
{
check_handle_ga(data);
data->f_rc++;
return data;
}

/* Member function 'copy1' not required for automem implementations */

inline GA & chg_popsize (const NAT1 & x2)
;

inline GA & chg_stringlen (const NAT1 & x2)
;

inline GA & chg_oldpop (const POPULATION & x2)
;

inline GA & chg_newpop (const POPULATION & x2)
;

inline GA & chg_pcross (const REAL & x2)
;

inline GA & chg_pmutation (const REAL & x2)
;

inline GA & chg_maxchange (const REAL & x2)
;

inline GA & chg_generation (const NAT0 & x2)
;

inline GA & chg_con (const CONTAINER & x2)
;

inline GA & chg_bl (const BLOCKS & x2)
;

inline GA & chg_containers (const NAT0 & x2)
;

GA & NextGen ()  ;

REAL GetFitness (const CHROMOSOME & x2)  ;

CHROMOSOME MakeChrom (const NAT1 & x2)  ;

inline void fpr (ostream & x1) const
;
inline friend ostream & operator << (ostream & x1, const GA & x2)
;

/* NOTE: Do not generate 'fpr' together with 'fprint' for C++ */
/* since both will be mapped to the operator '<<' !!! */

CHROMOSOME Mutation (const CHROMOSOME & x2)  ;

INDIVIDUAL Crossover (const INDIVIDUAL & x2, const INDIVIDUAL & x3 , INDIVIDUAL & r2)  ;

GA & Init (const CONTAINER & x2, const BLOCKS & x3, const NAT1 & x4, const NAT1 & x5, const REAL & x6, const REAL & x7, const REAL & x8)  ;

inline GA
(

const NAT1 & x_popsize_ga
,
const NAT1 & x_stringlen_ga
,
const POPULATION & x_oldpop_ga
,
const POPULATION & x_newpop_ga
,
const REAL & x_pcross_ga
,
const REAL & x_pmutation_ga
,
const REAL & x_maxchange_ga
,
const NAT0 & x_generation_ga
,
const CONTAINER & x_con_ga

,
const BLOCKS & x_bl_ga
,
const NAT0 & x_containers_ga

)
;

/* Member function 'del1' not required for automem implementations */

inline NAT1 popsize () const
;

inline NAT1 stringlen () const
;

inline POPULATION oldpop () const
;

inline POPULATION newpop () const
;

inline REAL pcross () const
;

inline REAL pmutation () const
;

inline REAL maxchange () const
;

inline NAT0 generation () const
;

inline CONTAINER con () const
;

inline BLOCKS bl () const
;

inline NAT0 containers () const
;

/* === Member function 'del' not required for automem implementations === */

};

/* ------- PHASE3 ------------------ */
inline BOOL BOOL :: not () const
{ return BOOL(not_bool (data));}

inline BOOL BOOL :: operator ! () const
{ return BOOL(not_bool (data));}

inline BOOL BOOL :: is_gr (const BOOL & x2) const
{ return BOOL(is_gr_bool (data, x2.data));}

inline BOOL BOOL :: operator > (const BOOL & x2) const
{ return BOOL(is_gr_bool (data, x2.data));}

inline BOOL BOOL :: xor (const BOOL & x2)
{ return BOOL(xor_bool (data, x2.data));}

inline BOOL & BOOL :: operator ^= (const BOOL & x2)
{ data = xor_bool (data, x2.data); return *this;}

inline BOOL BOOL :: operator ^ (const BOOL & x2)
{ return BOOL(xor_bool (data, x2.data));}

inline BOOL BOOL :: and (const BOOL & x2)
{ return BOOL(and_bool (data, x2.data));}

inline BOOL & BOOL :: operator &= (const BOOL & x2)
{ data = and_bool (data, x2.data); return *this;}

inline BOOL BOOL :: operator & (const BOOL & x2)
{ return BOOL(and_bool (data, x2.data));}

inline BOOL BOOL :: is_eq (const BOOL & x2) const
{ return BOOL(is_eq_bool (data, x2.data));}

inline BOOL BOOL :: operator == (const BOOL & x2) const
{ return BOOL(is_eq_bool (data, x2.data));}

inline BOOL BOOL :: operator != (const BOOL & x2) const
{ return BOOL((Bool)! is_eq_bool (data, x2.data));}

inline BOOL BOOL :: is_ge (const BOOL & x2) const
{ return BOOL(is_ge_bool (data, x2.data));}

inline BOOL BOOL :: operator >= (const BOOL & x2) const
{ return BOOL(is_ge_bool (data, x2.data));}

inline BOOL BOOL :: or (const BOOL & x2)
{ return BOOL(or_bool (data, x2.data));}

inline BOOL & BOOL :: operator |= (const BOOL & x2)
{ data = or_bool (data, x2.data); return *this;}

inline BOOL BOOL :: operator | (const BOOL & x2)
{ return BOOL(or_bool (data, x2.data));}

extern NILETC empty, nil, new_val;
typedef NILETC * mklc;

inline REAL REAL :: copy () const
{ return REAL(copy_real (data));}
inline void REAL :: set_print_format (char * x1) const
{ set_print_format_real (x1);}

inline void REAL :: set_print_format () const
{ set_print_format_real ((char *)0);}

inline REAL REAL :: minus (const REAL & x2) const
{ return REAL(minus_real (data, x2.data));}

inline REAL & REAL :: operator -= (const REAL & x2)
{ data = minus_real (data, x2.data); return *this;}

inline REAL REAL :: operator - (const REAL & x2) const
{ return REAL(minus_real (data, x2.data));}

inline REAL REAL :: div (const REAL & x2) const
{ return REAL(div_real (data, x2.data));}

inline REAL & REAL :: operator /= (const REAL & x2)
{ data = div_real (data, x2.data); return *this;}

inline REAL REAL :: operator / (const REAL & x2) const
{ return REAL(div_real (data, x2.data));}

inline BOOL REAL :: is_gr (const REAL & x2) const
{ return BOOL(is_gr_real (data, x2.data));}

inline BOOL REAL :: operator > (const REAL & x2) const
{ return BOOL(is_gr_real (data, x2.data));}

inline BOOL REAL :: is_le (const REAL & x2) const
{ return BOOL(is_le_real (data, x2.data));}

inline BOOL REAL :: operator <= (const REAL & x2) const
{ return BOOL(is_le_real (data, x2.data));}

inline REAL REAL :: succ ()
{ return REAL(succ_real (data));}

inline REAL & REAL :: operator ++ ()
{ data = succ_real (data); return *this;}

inline REAL REAL :: operator ++ (int)
{ REAL tmp=*this; { data = succ_real (data);}; return tmp; }

inline void REAL :: fpr (ostream & x1) const
{ fpr_real (x1, data);}
inline ostream & operator << (ostream & x1, const REAL & x2)
{ fpr_real (x1,x2.data); return x1; }

/* NOTE: Do not generate 'fpr' together with 'fprint' for C++ */
/* since both will be mapped to the operator '<<' !!! */

inline REAL REAL :: plus (const REAL & x2) const
{ return REAL(plus_real (data, x2.data));}

inline REAL & REAL :: operator += (const REAL & x2)
{ data = plus_real (data, x2.data); return *this;}

inline REAL REAL :: operator + (const REAL & x2) const
{ return REAL(plus_real (data, x2.data));}

inline REAL REAL :: times (const REAL & x2) const
{ return REAL(times_real (data, x2.data));}

inline REAL & REAL :: operator *= (const REAL & x2)
{ data = times_real (data, x2.data); return *this;}

inline REAL REAL :: operator * (const REAL & x2) const
{ return REAL(times_real (data, x2.data));}

inline BOOL REAL :: is_ge (const REAL & x2) const
{ return BOOL(is_ge_real (data, x2.data));}

inline BOOL REAL :: operator >= (const REAL & x2) const
{ return BOOL(is_ge_real (data, x2.data));}

inline BOOL REAL :: is_lt (const REAL & x2) const
{ return BOOL(is_lt_real (data, x2.data));}

inline BOOL REAL :: operator < (const REAL & x2) const
{ return BOOL(is_lt_real (data, x2.data));}

inline BOOL REAL :: is_eq (const REAL & x2) const
{ return BOOL(is_eq_real (data, x2.data));}

inline BOOL REAL :: operator == (const REAL & x2) const
{ return BOOL(is_eq_real (data, x2.data));}

inline BOOL REAL :: operator != (const REAL & x2) const
{ return BOOL((Bool)! is_eq_real (data, x2.data));}

inline BOOL REAL :: operator ! () const
{ return BOOL((Bool)! is_eq_real (data,((Real)0)));}

inline REAL REAL :: pred ()
{ return REAL(pred_real (data));}

inline REAL & REAL :: operator -- ()
{ data = pred_real (data); return *this;}

inline REAL REAL :: operator -- (int)
{ REAL tmp=*this; { data = pred_real (data);}; return tmp; }

inline void REAL :: del ()
{ del_real (data);}

inline
NAT1 :: NAT1 (const NAT0 & x1)
{
data = Nat1(x1.data);
}
inline
NAT1 :: operator NAT0 () const
{
return NAT0(Nat0(data));
}

inline void NAT1 :: set_print_format (char * x1) const
{ set_print_format_nat1 (x1);}

inline void NAT1 :: set_print_format () const
{ set_print_format_nat1 ((char *)0);}

inline NAT1 NAT1 :: pred ()
{ return NAT1(pred_nat1 (data));}

inline NAT1 & NAT1 :: operator -- ()
{ data = pred_nat1 (data); return *this;}

inline NAT1 NAT1 :: operator -- (int)
{ NAT1 tmp=*this; { data = pred_nat1 (data);}; return tmp; }

inline BOOL NAT1 :: is_eq (const NAT1 & x2) const
{ return BOOL(is_eq_nat1 (data, x2.data));}

inline BOOL NAT1 :: operator == (const NAT1 & x2) const
{ return BOOL(is_eq_nat1 (data, x2.data));}

inline BOOL NAT1 :: operator != (const NAT1 & x2) const
{ return BOOL((Bool)! is_eq_nat1 (data, x2.data));}

inline BOOL NAT1 :: operator ! () const
{ return BOOL((Bool)! is_eq_nat1 (data,((Nat1)0)));}

inline BOOL NAT1 :: is_lt (const NAT1 & x2) const
{ return BOOL(is_lt_nat1 (data, x2.data));}

inline BOOL NAT1 :: operator < (const NAT1 & x2) const
{ return BOOL(is_lt_nat1 (data, x2.data));}

inline BOOL NAT1 :: is_ge (const NAT1 & x2) const
{ return BOOL(is_ge_nat1 (data, x2.data));}

inline BOOL NAT1 :: operator >= (const NAT1 & x2) const
{ return BOOL(is_ge_nat1 (data, x2.data));}

inline NAT1 NAT1 :: times (const NAT1 & x2) const
{ return NAT1(times_nat1 (data, x2.data));}

inline NAT1 & NAT1 :: operator *= (const NAT1 & x2)
{ data = times_nat1 (data, x2.data); return *this;}

inline NAT1 NAT1 :: operator * (const NAT1 & x2) const
{ return NAT1(times_nat1 (data, x2.data));}

inline NAT1 NAT1 :: plus (const NAT1 & x2) const
{ return NAT1(plus_nat1 (data, x2.data));}

inline NAT1 & NAT1 :: operator += (const NAT1 & x2)
{ data = plus_nat1 (data, x2.data); return *this;}

inline NAT1 NAT1 :: operator + (const NAT1 & x2) const
{ return NAT1(plus_nat1 (data, x2.data));}

inline void NAT1 :: del ()
{ del_nat1 (data);}

inline NAT1 NAT1 :: copy () const
{ return NAT1(copy_nat1 (data));}

inline NAT1 NAT1 :: succ ()
{ return NAT1(succ_nat1 (data));}

inline NAT1 & NAT1 :: operator ++ ()
{ data = succ_nat1 (data); return *this;}

inline NAT1 NAT1 :: operator ++ (int)
{ NAT1 tmp=*this; { data = succ_nat1 (data);}; return tmp; }

inline NAT1 NAT1 :: mod (const NAT1 & x2) const
{ return NAT1(mod_nat1 (data, x2.data));}

inline NAT1 & NAT1 :: operator %= (const NAT1 & x2)
{ data = mod_nat1 (data, x2.data); return *this;}

inline NAT1 NAT1 :: operator % (const NAT1 & x2) const
{ return NAT1(mod_nat1 (data, x2.data));}

inline BOOL NAT1 :: is_le (const NAT1 & x2) const
{ return BOOL(is_le_nat1 (data, x2.data));}

inline BOOL NAT1 :: operator <= (const NAT1 & x2) const
{ return BOOL(is_le_nat1 (data, x2.data));}

inline BOOL NAT1 :: is_gr (const NAT1 & x2) const
{ return BOOL(is_gr_nat1 (data, x2.data));}

inline BOOL NAT1 :: operator > (const NAT1 & x2) const
{ return BOOL(is_gr_nat1 (data, x2.data));}

inline NAT1 NAT1 :: div (const NAT1 & x2) const
{ return NAT1(div_nat1 (data, x2.data));}

inline NAT1 & NAT1 :: operator /= (const NAT1 & x2)
{ data = div_nat1 (data, x2.data); return *this;}

inline NAT1 NAT1 :: operator / (const NAT1 & x2) const
{ return NAT1(div_nat1 (data, x2.data));}

inline NAT1 NAT1 :: minus (const NAT1 & x2) const
{ return NAT1(minus_nat1 (data, x2.data));}

inline NAT1 & NAT1 :: operator -= (const NAT1 & x2)
{ data = minus_nat1 (data, x2.data); return *this;}

inline NAT1 NAT1 :: operator - (const NAT1 & x2) const
{ return NAT1(minus_nat1 (data, x2.data));}

inline
NAT0 :: NAT0 (const INTG & x1)
{
data = Nat0(x1.data);
}

inline void NAT0 :: set_print_format (char * x1) const
{ set_print_format_nat0 (x1);}

inline void NAT0 :: set_print_format () const
{ set_print_format_nat0 ((char *)0);}

inline NAT0 NAT0 :: pred ()
{ return NAT0(pred_nat0 (data));}

inline NAT0 & NAT0 :: operator -- ()
{ data = pred_nat0 (data); return *this;}

inline NAT0 NAT0 :: operator -- (int)
{ NAT0 tmp=*this; { data = pred_nat0 (data);}; return tmp; }

inline BOOL NAT0 :: is_eq (const NAT0 & x2) const
{ return BOOL(is_eq_nat0 (data, x2.data));}

inline BOOL NAT0 :: operator == (const NAT0 & x2) const
{ return BOOL(is_eq_nat0 (data, x2.data));}

inline BOOL NAT0 :: operator != (const NAT0 & x2) const
{ return BOOL((Bool)! is_eq_nat0 (data, x2.data));}

inline BOOL NAT0 :: operator ! () const
{ return BOOL((Bool)! is_eq_nat0 (data,((Nat0)0)));}

inline BOOL NAT0 :: is_lt (const NAT0 & x2) const
{ return BOOL(is_lt_nat0 (data, x2.data));}

inline BOOL NAT0 :: operator < (const NAT0 & x2) const
{ return BOOL(is_lt_nat0 (data, x2.data));}

inline BOOL NAT0 :: is_ge (const NAT0 & x2) const
{ return BOOL(is_ge_nat0 (data, x2.data));}

inline BOOL NAT0 :: operator >= (const NAT0 & x2) const
{ return BOOL(is_ge_nat0 (data, x2.data));}

inline NAT0 NAT0 :: times (const NAT0 & x2) const
{ return NAT0(times_nat0 (data, x2.data));}

inline NAT0 & NAT0 :: operator *= (const NAT0 & x2)
{ data = times_nat0 (data, x2.data); return *this;}

inline NAT0 NAT0 :: operator * (const NAT0 & x2) const
{ return NAT0(times_nat0 (data, x2.data));}

inline NAT0 NAT0 :: plus (const NAT0 & x2) const
{ return NAT0(plus_nat0 (data, x2.data));}

inline NAT0 & NAT0 :: operator += (const NAT0 & x2)
{ data = plus_nat0 (data, x2.data); return *this;}

inline NAT0 NAT0 :: operator + (const NAT0 & x2) const
{ return NAT0(plus_nat0 (data, x2.data));}

inline void NAT0 :: del ()
{ del_nat0 (data);}

inline NAT0 NAT0 :: copy () const
{ return NAT0(copy_nat0 (data));}

inline NAT0 NAT0 :: succ ()
{ return NAT0(succ_nat0 (data));}

inline NAT0 & NAT0 :: operator ++ ()
{ data = succ_nat0 (data); return *this;}

inline NAT0 NAT0 :: operator ++ (int)
{ NAT0 tmp=*this; { data = succ_nat0 (data);}; return tmp; }

inline NAT0 NAT0 :: mod (const NAT0 & x2) const
{ return NAT0(mod_nat0 (data, x2.data));}

inline NAT0 & NAT0 :: operator %= (const NAT0 & x2)
{ data = mod_nat0 (data, x2.data); return *this;}

inline NAT0 NAT0 :: operator % (const NAT0 & x2) const
{ return NAT0(mod_nat0 (data, x2.data));}

inline BOOL NAT0 :: is_le (const NAT0 & x2) const
{ return BOOL(is_le_nat0 (data, x2.data));}

inline BOOL NAT0 :: operator <= (const NAT0 & x2) const
{ return BOOL(is_le_nat0 (data, x2.data));}

inline BOOL NAT0 :: is_gr (const NAT0 & x2) const
{ return BOOL(is_gr_nat0 (data, x2.data));}

inline BOOL NAT0 :: operator > (const NAT0 & x2) const
{ return BOOL(is_gr_nat0 (data, x2.data));}

inline NAT0 NAT0 :: div (const NAT0 & x2) const
{ return NAT0(div_nat0 (data, x2.data));}

inline NAT0 & NAT0 :: operator /= (const NAT0 & x2)
{ data = div_nat0 (data, x2.data); return *this;}

inline NAT0 NAT0 :: operator / (const NAT0 & x2) const
{ return NAT0(div_nat0 (data, x2.data));}

inline NAT0 NAT0 :: minus (const NAT0 & x2) const
{ return NAT0(minus_nat0 (data, x2.data));}

inline NAT0 & NAT0 :: operator -= (const NAT0 & x2)
{ data = minus_nat0 (data, x2.data); return *this;}

inline NAT0 NAT0 :: operator - (const NAT0 & x2) const
{ return NAT0(minus_nat0 (data, x2.data));}

inline INTG :: INTG (const NAT0 & x1)
{
data = Intg(x1.data);
}

inline INTG INTG :: pred ()
{ return INTG(pred_intg (data));}

inline INTG & INTG :: operator -- ()
{ data = pred_intg (data); return *this;}

inline INTG INTG :: operator -- (int)
{ INTG tmp=*this; { data = pred_intg (data);}; return tmp; }

inline BOOL INTG :: is_eq (const INTG & x2) const
{ return BOOL(is_eq_intg (data, x2.data));}

inline BOOL INTG :: operator == (const INTG & x2) const
{ return BOOL(is_eq_intg (data, x2.data));}

inline BOOL INTG :: operator != (const INTG & x2) const
{ return BOOL((Bool)! is_eq_intg (data, x2.data));}

inline BOOL INTG :: operator ! () const
{ return BOOL((Bool)! is_eq_intg (data,((Intg)0)));}

inline BOOL INTG :: is_lt (const INTG & x2) const
{ return BOOL(is_lt_intg (data, x2.data));}

inline BOOL INTG :: operator < (const INTG & x2) const
{ return BOOL(is_lt_intg (data, x2.data));}

inline BOOL INTG :: is_ge (const INTG & x2) const
{ return BOOL(is_ge_intg (data, x2.data));}

inline BOOL INTG :: operator >= (const INTG & x2) const
{ return BOOL(is_ge_intg (data, x2.data));}

inline INTG INTG :: times (const INTG & x2) const
{ return INTG(times_intg (data, x2.data));}

inline INTG & INTG :: operator *= (const INTG & x2)
{ data = times_intg (data, x2.data); return *this;}

inline INTG INTG :: operator * (const INTG & x2) const
{ return INTG(times_intg (data, x2.data));}

inline INTG INTG :: plus (const INTG & x2) const
{ return INTG(plus_intg (data, x2.data));}

inline INTG & INTG :: operator += (const INTG & x2)
{ data = plus_intg (data, x2.data); return *this;}

inline INTG INTG :: operator + (const INTG & x2) const
{ return INTG(plus_intg (data, x2.data));}

inline INTG INTG :: succ ()
{ return INTG(succ_intg (data));}

inline INTG & INTG :: operator ++ ()
{ data = succ_intg (data); return *this;}

inline INTG INTG :: operator ++ (int)
{ INTG tmp=*this; { data = succ_intg (data);}; return tmp; }

inline INTG INTG :: mod (const INTG & x2) const
{ return INTG(mod_intg (data, x2.data));}

inline INTG & INTG :: operator %= (const INTG & x2)
{ data = mod_intg (data, x2.data); return *this;}

inline INTG INTG :: operator % (const INTG & x2) const
{ return INTG(mod_intg (data, x2.data));}

inline BOOL INTG :: is_le (const INTG & x2) const
{ return BOOL(is_le_intg (data, x2.data));}

inline BOOL INTG :: operator <= (const INTG & x2) const
{ return BOOL(is_le_intg (data, x2.data));}

inline BOOL INTG :: is_gr (const INTG & x2) const
{ return BOOL(is_gr_intg (data, x2.data));}

inline BOOL INTG :: operator > (const INTG & x2) const
{ return BOOL(is_gr_intg (data, x2.data));}

inline INTG INTG :: div (const INTG & x2) const
{ return INTG(div_intg (data, x2.data));}

inline INTG & INTG :: operator /= (const INTG & x2)
{ data = div_intg (data, x2.data); return *this;}

inline INTG INTG :: operator / (const INTG & x2) const
{ return INTG(div_intg (data, x2.data));}

inline INTG INTG :: minus (const INTG & x2) const
{ return INTG(minus_intg (data, x2.data));}

inline INTG & INTG :: operator -= (const INTG & x2)
{ data = minus_intg (data, x2.data); return *this;}

inline INTG INTG :: operator - (const INTG & x2) const
{ return INTG(minus_intg (data, x2.data));}

inline
CHAR :: CHAR (const NAT0 & x1)
{
data = Char(x1.data);
}
inline
CHAR :: operator NAT0 () const
{
return NAT0(Nat0(data));
}

inline CHAR CHAR :: copy () const
{ return CHAR(copy_char (data));}

inline CHAR CHAR :: pred ()
{ return CHAR(pred_char (data));}

inline CHAR & CHAR :: operator -- ()
{ data = pred_char (data); return *this;}

inline CHAR CHAR :: operator -- (int)
{ CHAR tmp=*this; { data = pred_char (data);}; return tmp; }

inline BOOL CHAR :: is_eq (const CHAR & x2) const
{ return BOOL(is_eq_char (data, x2.data));}

inline BOOL CHAR :: operator == (const CHAR & x2) const
{ return BOOL(is_eq_char (data, x2.data));}

inline BOOL CHAR :: operator != (const CHAR & x2) const
{ return BOOL((Bool)! is_eq_char (data, x2.data));}

inline BOOL CHAR :: operator ! () const
{ return BOOL((Bool)! is_eq_char (data,((Char)0)));}

inline BOOL CHAR :: is_lt (const CHAR & x2) const
{ return BOOL(is_lt_char (data, x2.data));}

inline BOOL CHAR :: operator < (const CHAR & x2) const
{ return BOOL(is_lt_char (data, x2.data));}

inline BOOL CHAR :: is_ge (const CHAR & x2) const
{ return BOOL(is_ge_char (data, x2.data));}

inline BOOL CHAR :: operator >= (const CHAR & x2) const
{ return BOOL(is_ge_char (data, x2.data));}

inline CHAR CHAR :: times (const CHAR & x2) const
{ return CHAR(times_char (data, x2.data));}

inline CHAR & CHAR :: operator *= (const CHAR & x2)
{ data = times_char (data, x2.data); return *this;}

inline CHAR CHAR :: operator * (const CHAR & x2) const
{ return CHAR(times_char (data, x2.data));}

inline CHAR CHAR :: plus (const CHAR & x2) const
{ return CHAR(plus_char (data, x2.data));}

inline CHAR & CHAR :: operator += (const CHAR & x2)
{ data = plus_char (data, x2.data); return *this;}

inline CHAR CHAR :: operator + (const CHAR & x2) const
{ return CHAR(plus_char (data, x2.data));}

inline CHAR CHAR :: succ ()
{ return CHAR(succ_char (data));}

inline CHAR & CHAR :: operator ++ ()
{ data = succ_char (data); return *this;}

inline CHAR CHAR :: operator ++ (int)
{ CHAR tmp=*this; { data = succ_char (data);}; return tmp; }

inline CHAR CHAR :: mod (const CHAR & x2) const
{ return CHAR(mod_char (data, x2.data));}

inline CHAR & CHAR :: operator %= (const CHAR & x2)
{ data = mod_char (data, x2.data); return *this;}

inline CHAR CHAR :: operator % (const CHAR & x2) const
{ return CHAR(mod_char (data, x2.data));}

inline BOOL CHAR :: is_le (const CHAR & x2) const
{ return BOOL(is_le_char (data, x2.data));}

inline BOOL CHAR :: operator <= (const CHAR & x2) const
{ return BOOL(is_le_char (data, x2.data));}

inline BOOL CHAR :: is_gr (const CHAR & x2) const
{ return BOOL(is_gr_char (data, x2.data));}

inline BOOL CHAR :: operator > (const CHAR & x2) const
{ return BOOL(is_gr_char (data, x2.data));}

inline CHAR CHAR :: div (const CHAR & x2) const
{ return CHAR(div_char (data, x2.data));}

inline CHAR & CHAR :: operator /= (const CHAR & x2)
{ data = div_char (data, x2.data); return *this;}

inline CHAR CHAR :: operator / (const CHAR & x2) const
{ return CHAR(div_char (data, x2.data));}

inline CHAR CHAR :: minus (const CHAR & x2) const
{ return CHAR(minus_char (data, x2.data));}

inline CHAR & CHAR :: operator -= (const CHAR & x2)
{ data = minus_char (data, x2.data); return *this;}

inline CHAR CHAR :: operator - (const CHAR & x2) const
{ return CHAR(minus_char (data, x2.data));}

inline void CHAR :: del ()
{ del_char (data);}

inline NAT0 STR :: len () const
{ return NAT0(len_str (data));}
inline NAT0 STR :: index (const CHAR & x2) const
{ return NAT0(index_str (data, x2.data));}
inline CHAR STR :: hd () const
{ return CHAR(hd_str (data));}

inline STR & STR :: conc (const STR & x2)
{ data = conc_auto_str (data, x2.data); return *this;}

inline STR & STR :: operator += (const STR & x2)
{ data = conc_auto_str (data, x2.data); return *this;}

inline STR STR :: operator + (const STR & x2) const
{ STR tmp=*this; tmp.data=conc_auto_str(tmp.data,x2.data); return tmp; }

inline CHAR STR :: sel (const NAT1 & x2) const
{ return CHAR(sel_str (data, x2.data));}
inline CHAR STR :: operator [] (const NAT1 & x2) const
{ return CHAR(sel_str (data,x2.data));}
inline void STR :: cpc (char * x2) const
{ cpc_str (data,x2);}
inline STR :: STR (char * x1)
{ data = mkc_str (x1);}

/* === Member function 'del' not required for automem implementations === */

/* === Member function 'copy' not required for automem implementations === */
inline STR & STR :: ovwrt1 (const NAT1 & x2, const CHAR & x3)
{ data = ovwrt1_str (data, x2.data, x3.data); return *this;}
inline STR :: STR (const CHAR & x1, const NAT0 & x2)
{ data = mkn_str (x1.data, x2.data);}
/* === Member function 'copy' not required for automem implementations === */
inline NAT0 CHROMOSOME :: len () const
{ return NAT0(len_chromosome (data));}

inline CHROMOSOME & CHROMOSOME :: appr (const GEN & x2)
{ data = appr_chromosome (data, x2.data); return *this;}

inline CHROMOSOME & CHROMOSOME :: operator += (const GEN & x2)
{ data = appr_chromosome (data, x2.data); return *this;}

inline CHROMOSOME CHROMOSOME :: operator + (const GEN & x2) const
{ CHROMOSOME tmp=*this; tmp.data=appr_chromosome(tmp.data,x2.data); return tmp; }

/* Member function 'copy1' not required for automem implementations */

inline CHROMOSOME & CHROMOSOME :: appl (const GEN & x1)
{ data = appl_chromosome (x1.data, data); return *this;}
inline CHROMOSOME operator + (const GEN & x1, CHROMOSOME & x2)
{CHROMOSOME tmp = x2; tmp.data = appl_chromosome(x1.data, tmp.data); return tmp;}

inline BOOL CHROMOSOME :: is_empty () const
{ return BOOL(is_empty_chromosome (data));}

inline BOOL CHROMOSOME :: operator ! () const
{ return BOOL(! is_empty_chromosome (data));}

inline CHROMOSOME & CHROMOSOME :: ovwrt1 (const NAT1 & x2, const GEN & x3)
{ data = ovwrt1_chromosome (data, x2.data, x3.data); return *this;}
inline CHROMOSOME & CHROMOSOME :: rmv1 (const NAT1 & x2)
{ data = rmv1_chromosome (data, x2.data); return *this;}
inline CHROMOSOME :: CHROMOSOME (const GEN & x1, const NAT0 & x2)
{ data = mkn_chromosome (x1.data, x2.data);}
inline void CHROMOSOME :: fpr (ostream & x1) const
{ fpr_chromosome (x1, data);}
inline ostream & operator << (ostream & x1, const CHROMOSOME & x2)
{ fpr_chromosome (x1,x2.data); return x1; }

/* NOTE: Do not generate 'fpr' together with 'fprint' for C++ */
/* since both will be mapped to the operator '<<' !!! */

inline CHROMOSOME :: CHROMOSOME (const NILETC & x1)
{ data = mk_empty_chromosome ();}
inline GEN CHROMOSOME :: hd () const
{ return GEN(hd_chromosome (data));}

inline CHROMOSOME & CHROMOSOME :: conc (const CHROMOSOME & x2)
{ data = conc_chromosome (data, x2.data); return *this;}

inline CHROMOSOME & CHROMOSOME :: operator += (const CHROMOSOME & x2)
{ data = conc_chromosome (data, x2.data); return *this;}

inline CHROMOSOME CHROMOSOME :: operator + (const CHROMOSOME & x2) const
{ CHROMOSOME tmp=*this; tmp.data=conc_chromosome(tmp.data,x2.data); return tmp; }

/* Member function 'del1' not required for automem implementations */

inline CHROMOSOME & CHROMOSOME :: tl ()
{ data = tl_chromosome (data); return *this;}
inline GEN CHROMOSOME :: sel (const NAT1 & x2) const
{ return GEN(sel_chromosome (data, x2.data));}
inline GEN CHROMOSOME :: operator [] (const NAT1 & x2) const
{ return GEN(sel_chromosome (data,x2.data));}
inline CHROMOSOME :: CHROMOSOME (const GEN & x1)
{ data = mk1_chromosome (x1.data);}

/* === Member function 'del' not required for automem implementations === */

/* === Member function 'copy' not required for automem implementations === */

/* === Member function 'del' not required for automem implementations === */

inline NAT0 CONTAINER :: cwidth () const
{ return NAT0(s_cwidth_container (data));}

inline NAT0 CONTAINER :: cheight () const
{ return NAT0(s_cheight_container (data));}

/* Member function 'del1' not required for automem implementations */

inline CONTAINER :: CONTAINER
(

const NAT0 & x_cwidth_container
,
const NAT0 & x_cheight_container

)
{ data = mk_container (

x_cwidth_container.data
,
x_cheight_container.data

);}
inline void CONTAINER :: fpr (ostream & x1) const
{ fpr_container (x1, data);}
inline ostream & operator << (ostream & x1, const CONTAINER & x2)
{ fpr_container (x1,x2.data); return x1; }

/* NOTE: Do not generate 'fpr' together with 'fprint' for C++ */
/* since both will be mapped to the operator '<<' !!! */

inline CONTAINER & CONTAINER :: chg_cwidth (const NAT0 & x2)
{ data = chg_cwidth_container (data, x2.data); return *this;}

inline CONTAINER & CONTAINER :: chg_cheight (const NAT0 & x2)
{ data = chg_cheight_container (data, x2.data); return *this;}

/* Member function 'copy1' not required for automem implementations */

/* Member function 'copy1' not required for automem implementations */

inline BLOCK & BLOCK :: chg_bwidth (const NAT0 & x2)
{ data = chg_bwidth_block (data, x2.data); return *this;}

inline BLOCK & BLOCK :: chg_bheight (const NAT0 & x2)
{ data = chg_bheight_block (data, x2.data); return *this;}

inline BLOCK & BLOCK :: chg_x (const NAT0 & x2)
{ data = chg_x_block (data, x2.data); return *this;}

inline BLOCK & BLOCK :: chg_y (const NAT0 & x2)
{ data = chg_y_block (data, x2.data); return *this;}

inline void BLOCK :: fpr (ostream & x1) const
{ fpr_block (x1, data);}
inline ostream & operator << (ostream & x1, const BLOCK & x2)
{ fpr_block (x1,x2.data); return x1; }

/* NOTE: Do not generate 'fpr' together with 'fprint' for C++ */
/* since both will be mapped to the operator '<<' !!! */

/* === Member function 'copy' not required for automem implementations === */
inline BLOCK :: BLOCK
(

const NAT0 & x_bwidth_block
,
const NAT0 & x_bheight_block
,
const NAT0 & x_x_block
,
const NAT0 & x_y_block

)
{ data = mk_block (

x_bwidth_block.data
,
x_bheight_block.data
,
x_x_block.data
,
x_y_block.data

);}

/* Member function 'del1' not required for automem implementations */

inline NAT0 BLOCK :: bwidth () const
{ return NAT0(s_bwidth_block (data));}

inline NAT0 BLOCK :: bheight () const
{ return NAT0(s_bheight_block (data));}

inline NAT0 BLOCK :: x () const
{ return NAT0(s_x_block (data));}

inline NAT0 BLOCK :: y () const
{ return NAT0(s_y_block (data));}

/* === Member function 'del' not required for automem implementations === */

/* === Member function 'del' not required for automem implementations === */

inline CONFILL :: CONFILL (const NAT0 & x1)
{ data = mk1_confill (x1.data);}

inline NAT0 CONFILL :: sel (const NAT1 & x2) const
{ return NAT0(sel_confill (data, x2.data));}
inline NAT0 CONFILL :: operator [] (const NAT1 & x2) const
{ return NAT0(sel_confill (data,x2.data));}
inline CONFILL & CONFILL :: tl ()
{ data = tl_confill (data); return *this;}

/* Member function 'del1' not required for automem implementations */

inline CONFILL & CONFILL :: conc (const CONFILL & x2)
{ data = conc_confill (data, x2.data); return *this;}

inline CONFILL & CONFILL :: operator += (const CONFILL & x2)
{ data = conc_confill (data, x2.data); return *this;}

inline CONFILL CONFILL :: operator + (const CONFILL & x2) const
{ CONFILL tmp=*this; tmp.data=conc_confill(tmp.data,x2.data); return tmp; }

inline NAT0 CONFILL :: hd () const
{ return NAT0(hd_confill (data));}
inline CONFILL :: CONFILL (const NILETC & x1)
{ data = mk_empty_confill ();}
inline void CONFILL :: fpr (ostream & x1) const
{ fpr_confill (x1, data);}
inline ostream & operator << (ostream & x1, const CONFILL & x2)
{ fpr_confill (x1,x2.data); return x1; }

/* NOTE: Do not generate 'fpr' together with 'fprint' for C++ */
/* since both will be mapped to the operator '<<' !!! */

inline CONFILL :: CONFILL (const NAT0 & x1, const NAT0 & x2)
{ data = mkn_confill (x1.data, x2.data);}
inline CONFILL & CONFILL :: ovwrt1 (const NAT1 & x2, const NAT0 & x3)
{ data = ovwrt1_confill (data, x2.data, x3.data); return *this;}

inline BOOL CONFILL :: is_empty () const
{ return BOOL(is_empty_confill (data));}

inline BOOL CONFILL :: operator ! () const
{ return BOOL(! is_empty_confill (data));}

inline CONFILL & CONFILL :: appl (const NAT0 & x1)
{ data = appl_confill (x1.data, data); return *this;}
inline CONFILL operator + (const NAT0 & x1, CONFILL & x2)
{CONFILL tmp = x2; tmp.data = appl_confill(x1.data, tmp.data); return tmp;}

/* Member function 'copy1' not required for automem implementations */

inline CONFILL & CONFILL :: appr (const NAT0 & x2)
{ data = appr_confill (data, x2.data); return *this;}

inline CONFILL & CONFILL :: operator += (const NAT0 & x2)
{ data = appr_confill (data, x2.data); return *this;}

inline CONFILL CONFILL :: operator + (const NAT0 & x2) const
{ CONFILL tmp=*this; tmp.data=appr_confill(tmp.data,x2.data); return tmp; }

inline NAT0 CONFILL :: len () const
{ return NAT0(len_confill (data));}
inline BOOL ITER_CHROMOSOME :: is_empty ()
{ return BOOL(is_empty_iter_chromosome (&(data)));}

inline BOOL ITER_CHROMOSOME :: operator ! ()
{ return BOOL(! is_empty_iter_chromosome (&(data)));}

/* === Member function 'del' not required for automem implementations === */

inline ITER_CHROMOSOME :: ITER_CHROMOSOME (CHROMOSOME x1)
{ data = mk_iter_chromosome (x1.data);}
inline GEN ITER_CHROMOSOME :: sel ()
{ return GEN(sel_iter_chromosome (&(data)));}
inline void ITER_CHROMOSOME :: next ()
{ next_iter_chromosome (&(data));}

inline void ITER_CHROMOSOME :: operator ++ ()
{ next_iter_chromosome (&(data));}

inline void ITER_CHROMOSOME :: operator ++ (int)
{ next_iter_chromosome (&(data));}
inline BOOL ITER_CONFILL :: is_empty ()
{ return BOOL(is_empty_iter_confill (&(data)));}

inline BOOL ITER_CONFILL :: operator ! ()
{ return BOOL(! is_empty_iter_confill (&(data)));}

/* === Member function 'del' not required for automem implementations === */

inline ITER_CONFILL :: ITER_CONFILL (CONFILL x1)
{ data = mk_iter_confill (x1.data);}
inline NAT0 ITER_CONFILL :: sel ()
{ return NAT0(sel_iter_confill (&(data)));}
inline void ITER_CONFILL :: next ()
{ next_iter_confill (&(data));}

inline void ITER_CONFILL :: operator ++ ()
{ next_iter_confill (&(data));}

inline void ITER_CONFILL :: operator ++ (int)
{ next_iter_confill (&(data));}

/* Member function 'copy1' not required for automem implementations */

inline INDIVIDUAL & INDIVIDUAL :: chg_chrom (const CHROMOSOME & x2)
{ data = chg_chrom_individual (data, x2.data); return *this;}

inline INDIVIDUAL & INDIVIDUAL :: chg_fitness (const REAL & x2)
{ data = chg_fitness_individual (data, x2.data); return *this;}

inline void INDIVIDUAL :: fpr (ostream & x1) const
{ fpr_individual (x1, data);}
inline ostream & operator << (ostream & x1, const INDIVIDUAL & x2)
{ fpr_individual (x1,x2.data); return x1; }

/* NOTE: Do not generate 'fpr' together with 'fprint' for C++ */
/* since both will be mapped to the operator '<<' !!! */

/* === Member function 'copy' not required for automem implementations === */
inline INDIVIDUAL :: INDIVIDUAL
(

const CHROMOSOME & x_chrom_individual
,
const REAL & x_fitness_individual

)
{ data = mk_individual (

x_chrom_individual.data
,
x_fitness_individual.data

);}

/* Member function 'del1' not required for automem implementations */

inline CHROMOSOME INDIVIDUAL :: chrom () const
{ return CHROMOSOME(s_chrom_individual (data));}

inline REAL INDIVIDUAL :: fitness () const
{ return REAL(s_fitness_individual (data));}

/* === Member function 'del' not required for automem implementations === */

/* === Member function 'copy' not required for automem implementations === */
inline NAT0 BLOCKS :: len () const
{ return NAT0(len_blocks (data));}

inline BLOCKS & BLOCKS :: appr (const BLOCK & x2)
{ data = appr_blocks (data, x2.data); return *this;}

inline BLOCKS & BLOCKS :: operator += (const BLOCK & x2)
{ data = appr_blocks (data, x2.data); return *this;}

inline BLOCKS BLOCKS :: operator + (const BLOCK & x2) const
{ BLOCKS tmp=*this; tmp.data=appr_blocks(tmp.data,x2.data); return tmp; }

/* Member function 'copy1' not required for automem implementations */

inline BLOCKS & BLOCKS :: appl (const BLOCK & x1)
{ data = appl_blocks (x1.data, data); return *this;}
inline BLOCKS operator + (const BLOCK & x1, BLOCKS & x2)
{BLOCKS tmp = x2; tmp.data = appl_blocks(x1.data, tmp.data); return tmp;}

inline BOOL BLOCKS :: is_empty () const
{ return BOOL(is_empty_blocks (data));}

inline BOOL BLOCKS :: operator ! () const
{ return BOOL(! is_empty_blocks (data));}

inline BLOCKS & BLOCKS :: ovwrt1 (const NAT1 & x2, const BLOCK & x3)
{ data = ovwrt1_blocks (data, x2.data, x3.data); return *this;}
inline BLOCKS :: BLOCKS (const BLOCK & x1, const NAT0 & x2)
{ data = mkn_blocks (x1.data, x2.data);}
inline void BLOCKS :: fpr (ostream & x1) const
{ fpr_blocks (x1, data);}
inline ostream & operator << (ostream & x1, const BLOCKS & x2)
{ fpr_blocks (x1,x2.data); return x1; }

/* NOTE: Do not generate 'fpr' together with 'fprint' for C++ */
/* since both will be mapped to the operator '<<' !!! */

inline BLOCKS :: BLOCKS (const NILETC & x1)
{ data = mk_empty_blocks ();}
inline BLOCK BLOCKS :: hd () const
{ return BLOCK(hd_blocks (data));}

inline BLOCKS & BLOCKS :: conc (const BLOCKS & x2)
{ data = conc_blocks (data, x2.data); return *this;}

inline BLOCKS & BLOCKS :: operator += (const BLOCKS & x2)
{ data = conc_blocks (data, x2.data); return *this;}

inline BLOCKS BLOCKS :: operator + (const BLOCKS & x2) const
{ BLOCKS tmp=*this; tmp.data=conc_blocks(tmp.data,x2.data); return tmp; }

/* Member function 'del1' not required for automem implementations */

inline BLOCKS & BLOCKS :: tl ()
{ data = tl_blocks (data); return *this;}
inline BLOCK BLOCKS :: sel (const NAT1 & x2) const
{ return BLOCK(sel_blocks (data, x2.data));}
inline BLOCK BLOCKS :: operator [] (const NAT1 & x2) const
{ return BLOCK(sel_blocks (data,x2.data));}
inline BLOCKS :: BLOCKS (const BLOCK & x1)
{ data = mk1_blocks (x1.data);}

/* === Member function 'del' not required for automem implementations === */

inline BOOL ITER_BLOCKS :: is_empty ()
{ return BOOL(is_empty_iter_blocks (&(data)));}

inline BOOL ITER_BLOCKS :: operator ! ()
{ return BOOL(! is_empty_iter_blocks (&(data)));}

/* === Member function 'del' not required for automem implementations === */

inline ITER_BLOCKS :: ITER_BLOCKS (BLOCKS x1)
{ data = mk_iter_blocks (x1.data);}
inline BLOCK ITER_BLOCKS :: sel ()
{ return BLOCK(sel_iter_blocks (&(data)));}
inline void ITER_BLOCKS :: next ()
{ next_iter_blocks (&(data));}

inline void ITER_BLOCKS :: operator ++ ()
{ next_iter_blocks (&(data));}

inline void ITER_BLOCKS :: operator ++ (int)
{ next_iter_blocks (&(data));}
/* === Member function 'copy' not required for automem implementations === */
inline NAT0 INDIVIDUALS :: len () const
{ return NAT0(len_individuals (data));}

inline INDIVIDUALS & INDIVIDUALS :: appr (const INDIVIDUAL & x2)
{ data = appr_individuals (data, x2.data); return *this;}

inline INDIVIDUALS & INDIVIDUALS :: operator += (const INDIVIDUAL & x2)
{ data = appr_individuals (data, x2.data); return *this;}

inline INDIVIDUALS INDIVIDUALS :: operator + (const INDIVIDUAL & x2) const
{ INDIVIDUALS tmp=*this; tmp.data=appr_individuals(tmp.data,x2.data); return tmp; }

/* Member function 'copy1' not required for automem implementations */

inline INDIVIDUALS & INDIVIDUALS :: appl (const INDIVIDUAL & x1)
{ data = appl_individuals (x1.data, data); return *this;}
inline INDIVIDUALS operator + (const INDIVIDUAL & x1, INDIVIDUALS & x2)
{INDIVIDUALS tmp = x2; tmp.data = appl_individuals(x1.data, tmp.data); return tmp;}

inline BOOL INDIVIDUALS :: is_empty () const
{ return BOOL(is_empty_individuals (data));}

inline BOOL INDIVIDUALS :: operator ! () const
{ return BOOL(! is_empty_individuals (data));}

inline INDIVIDUALS & INDIVIDUALS :: ovwrt1 (const NAT1 & x2, const INDIVIDUAL & x3)
{ data = ovwrt1_individuals (data, x2.data, x3.data); return *this;}
inline INDIVIDUALS :: INDIVIDUALS (const INDIVIDUAL & x1, const NAT0 & x2)
{ data = mkn_individuals (x1.data, x2.data);}
inline void INDIVIDUALS :: fpr (ostream & x1) const
{ fpr_individuals (x1, data);}
inline ostream & operator << (ostream & x1, const INDIVIDUALS & x2)
{ fpr_individuals (x1,x2.data); return x1; }

/* NOTE: Do not generate 'fpr' together with 'fprint' for C++ */
/* since both will be mapped to the operator '<<' !!! */

inline INDIVIDUALS :: INDIVIDUALS (const NILETC & x1)
{ data = mk_empty_individuals ();}
inline INDIVIDUAL INDIVIDUALS :: hd () const
{ return INDIVIDUAL(hd_individuals (data));}

inline INDIVIDUALS & INDIVIDUALS :: conc (const INDIVIDUALS & x2)
{ data = conc_individuals (data, x2.data); return *this;}

inline INDIVIDUALS & INDIVIDUALS :: operator += (const INDIVIDUALS & x2)
{ data = conc_individuals (data, x2.data); return *this;}

inline INDIVIDUALS INDIVIDUALS :: operator + (const INDIVIDUALS & x2) const
{ INDIVIDUALS tmp=*this; tmp.data=conc_individuals(tmp.data,x2.data); return tmp; }

/* Member function 'del1' not required for automem implementations */

inline INDIVIDUALS & INDIVIDUALS :: tl ()
{ data = tl_individuals (data); return *this;}
inline INDIVIDUAL INDIVIDUALS :: sel (const NAT1 & x2) const
{ return INDIVIDUAL(sel_individuals (data, x2.data));}
inline INDIVIDUAL INDIVIDUALS :: operator [] (const NAT1 & x2) const
{ return INDIVIDUAL(sel_individuals (data,x2.data));}
inline INDIVIDUALS :: INDIVIDUALS (const INDIVIDUAL & x1)
{ data = mk1_individuals (x1.data);}

/* === Member function 'del' not required for automem implementations === */

inline BOOL ITER_INDIVIDUALS :: is_empty ()
{ return BOOL(is_empty_iter_individuals (&(data)));}

inline BOOL ITER_INDIVIDUALS :: operator ! ()
{ return BOOL(! is_empty_iter_individuals (&(data)));}

/* === Member function 'del' not required for automem implementations === */

inline ITER_INDIVIDUALS :: ITER_INDIVIDUALS (INDIVIDUALS x1)
{ data = mk_iter_individuals (x1.data);}
inline INDIVIDUAL ITER_INDIVIDUALS :: sel ()
{ return INDIVIDUAL(sel_iter_individuals (&(data)));}
inline void ITER_INDIVIDUALS :: next ()
{ next_iter_individuals (&(data));}

inline void ITER_INDIVIDUALS :: operator ++ ()
{ next_iter_individuals (&(data));}

inline void ITER_INDIVIDUALS :: operator ++ (int)
{ next_iter_individuals (&(data));}
/* === Member function 'copy' not required for automem implementations === */

/* === Member function 'del' not required for automem implementations === */

inline INDIVIDUALS POPULATION :: ind () const
{ return INDIVIDUALS(s_ind_population (data));}

inline NAT1 POPULATION :: popsize () const
{ return NAT1(s_popsize_population (data));}

inline NAT1 POPULATION :: stringlen () const
{ return NAT1(s_stringlen_population (data));}

inline NAT1 POPULATION :: step () const
{ return NAT1(s_step_population (data));}

inline NAT1 POPULATION :: best () const
{ return NAT1(s_best_population (data));}

inline NAT1 POPULATION :: worst () const
{ return NAT1(s_worst_population (data));}

inline REAL POPULATION :: bestf () const
{ return REAL(s_bestf_population (data));}

inline REAL POPULATION :: worstf () const
{ return REAL(s_worstf_population (data));}

inline REAL POPULATION :: sumfitness () const
{ return REAL(s_sumfitness_population (data));}

/* Member function 'del1' not required for automem implementations */

inline POPULATION :: POPULATION
(

const INDIVIDUALS & x_ind_population
,
const NAT1 & x_popsize_population
,
const NAT1 & x_stringlen_population
,
const NAT1 & x_step_population
,
const NAT1 & x_best_population
,
const NAT1 & x_worst_population
,
const REAL & x_bestf_population
,
const REAL & x_worstf_population
,
const REAL & x_sumfitness_population

)
{ data = mk_population (

x_ind_population.data
,
x_popsize_population.data
,
x_stringlen_population.data
,
x_step_population.data
,
x_best_population.data
,
x_worst_population.data
,
x_bestf_population.data
,
x_worstf_population.data
,
x_sumfitness_population.data

);}
inline void POPULATION :: fpr (ostream & x1) const
{ fpr_population (x1, data);}
inline ostream & operator << (ostream & x1, const POPULATION & x2)
{ fpr_population (x1,x2.data); return x1; }

/* NOTE: Do not generate 'fpr' together with 'fprint' for C++ */
/* since both will be mapped to the operator '<<' !!! */

inline POPULATION & POPULATION :: chg_ind (const INDIVIDUALS & x2)
{ data = chg_ind_population (data, x2.data); return *this;}

inline POPULATION & POPULATION :: chg_popsize (const NAT1 & x2)
{ data = chg_popsize_population (data, x2.data); return *this;}

inline POPULATION & POPULATION :: chg_stringlen (const NAT1 & x2)
{ data = chg_stringlen_population (data, x2.data); return *this;}

inline POPULATION & POPULATION :: chg_step (const NAT1 & x2)
{ data = chg_step_population (data, x2.data); return *this;}

inline POPULATION & POPULATION :: chg_best (const NAT1 & x2)
{ data = chg_best_population (data, x2.data); return *this;}

inline POPULATION & POPULATION :: chg_worst (const NAT1 & x2)
{ data = chg_worst_population (data, x2.data); return *this;}

inline POPULATION & POPULATION :: chg_bestf (const REAL & x2)
{ data = chg_bestf_population (data, x2.data); return *this;}

inline POPULATION & POPULATION :: chg_worstf (const REAL & x2)
{ data = chg_worstf_population (data, x2.data); return *this;}

inline POPULATION & POPULATION :: chg_sumfitness (const REAL & x2)
{ data = chg_sumfitness_population (data, x2.data); return *this;}

/* Member function 'copy1' not required for automem implementations */

/* Member function 'copy1' not required for automem implementations */

inline GA & GA :: chg_popsize (const NAT1 & x2)
{ data = chg_popsize_ga (data, x2.data); return *this;}

inline GA & GA :: chg_stringlen (const NAT1 & x2)
{ data = chg_stringlen_ga (data, x2.data); return *this;}

inline GA & GA :: chg_oldpop (const POPULATION & x2)
{ data = chg_oldpop_ga (data, x2.data); return *this;}

inline GA & GA :: chg_newpop (const POPULATION & x2)
{ data = chg_newpop_ga (data, x2.data); return *this;}

inline GA & GA :: chg_pcross (const REAL & x2)
{ data = chg_pcross_ga (data, x2.data); return *this;}

inline GA & GA :: chg_pmutation (const REAL & x2)
{ data = chg_pmutation_ga (data, x2.data); return *this;}

inline GA & GA :: chg_maxchange (const REAL & x2)
{ data = chg_maxchange_ga (data, x2.data); return *this;}

inline GA & GA :: chg_generation (const NAT0 & x2)
{ data = chg_generation_ga (data, x2.data); return *this;}

inline GA & GA :: chg_con (const CONTAINER & x2)
{ data = chg_con_ga (data, x2.data); return *this;}

inline GA & GA :: chg_bl (const BLOCKS & x2)
{ data = chg_bl_ga (data, x2.data); return *this;}

inline GA & GA :: chg_containers (const NAT0 & x2)
{ data = chg_containers_ga (data, x2.data); return *this;}

inline void GA :: fpr (ostream & x1) const
{ fpr_ga (x1, data);}
inline ostream & operator << (ostream & x1, const GA & x2)
{ fpr_ga (x1,x2.data); return x1; }

/* NOTE: Do not generate 'fpr' together with 'fprint' for C++ */
/* since both will be mapped to the operator '<<' !!! */

inline GA :: GA
(

const NAT1 & x_popsize_ga
,
const NAT1 & x_stringlen_ga
,
const POPULATION & x_oldpop_ga
,
const POPULATION & x_newpop_ga
,
const REAL & x_pcross_ga
,
const REAL & x_pmutation_ga
,
const REAL & x_maxchange_ga
,
const NAT0 & x_generation_ga
,
const CONTAINER & x_con_ga

,
const BLOCKS & x_bl_ga
,
const NAT0 & x_containers_ga

)
{ data = mk_ga (

x_popsize_ga.data
,
x_stringlen_ga.data
,
x_oldpop_ga.data
,
x_newpop_ga.data
,
x_pcross_ga.data
,
x_pmutation_ga.data
,
x_maxchange_ga.data
,
x_generation_ga.data
,
x_con_ga.data

,
x_bl_ga.data
,
x_containers_ga.data

);}

/* Member function 'del1' not required for automem implementations */

inline NAT1 GA :: popsize () const
{ return NAT1(s_popsize_ga (data));}

inline NAT1 GA :: stringlen () const
{ return NAT1(s_stringlen_ga (data));}

inline POPULATION GA :: oldpop () const
{ return POPULATION(s_oldpop_ga (data));}

inline POPULATION GA :: newpop () const
{ return POPULATION(s_newpop_ga (data));}

inline REAL GA :: pcross () const
{ return REAL(s_pcross_ga (data));}

inline REAL GA :: pmutation () const
{ return REAL(s_pmutation_ga (data));}

inline REAL GA :: maxchange () const
{ return REAL(s_maxchange_ga (data));}

inline NAT0 GA :: generation () const
{ return NAT0(s_generation_ga (data));}

inline CONTAINER GA :: con () const
{ return CONTAINER(s_con_ga (data));}

inline BLOCKS GA :: bl () const
{ return BLOCKS(s_bl_ga (data));}

inline NAT0 GA :: containers () const
{ return NAT0(s_containers_ga (data));}

/* === Member function 'del' not required for automem implementations === */

/* ------- PHASEEND ------------------ */

#endif
